> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.solvimon.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.solvimon.com/_mcp/server.

# Create a one-off invoice or credit invoice

POST https://test.api.solvimon.com/v{version}/invoices
Content-Type: application/json

Requires the INVOICE.ONE_OFF.CREATE permission.

Reference: https://docs.solvimon.com/api-docs/transaction-api/invoices/post-invoices

## Authentication

- `X-API-KEY` header (required) — API Key authentication via header
- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://test.api.solvimon.com` (The TEST environment for our API, default)
- `https://api.solvimon.com` (The live environment for our API)

## Request

### Path parameters

- `version` (string, required, default: 1) — version

### Headers

- `x-platform-id` (string, optional) — Platform ID.

### Body (application/json)

This endpoint expects an InvoiceCreateRequest.

- `type` (enum, required)
  - Allowed values: `STANDARD`, `CREDIT`, `ONE_OFF`, `ONE_OFF_CREDIT`
- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `invoice_number` (string, optional, nullable)
- `purchase_order_number` (string, optional, nullable)
- `platform_id` (string, optional, nullable)
- `customer_id` (string, optional, nullable) — id of the customer, can only be provided when creating a one-off invoice, and either id or reference is mandatory in that case
- `customer_reference` (string, optional, nullable) — reference of the customer, can only be provided when creating a one-off invoice, and either id or reference is mandatory in that case
- `sales_tax_percentage` (string, optional, nullable) — Sales tax percentage. Needs to be present if both customer and billing entity are US-based. Optional if one of them is US-based
- `customer` (CustomerCreateRequest, optional, nullable)
- `billing_entity_id` (string, optional) — id of the billing entity, can only be provided for a one-off invoice. If not provided, the default of the platform will be used
- `billing_entity` (BillingEntityCreateRequest, optional, nullable)
- `status` (string, optional)
- `on_hold` (boolean, optional)
- `created_at` (string, optional, nullable)
- `updated_at` (string, optional, nullable)
- `invoice_date` (datetime, optional)
- `delivery_date` (string, optional, nullable)
- `due_date` (datetime, optional, nullable)
- `billing_period_date` (string, optional, nullable)
- `billing_currency` (string, optional, nullable)
- `invoice_amount_including_tax` (AmountCreateRequest, optional, nullable)
- `open_invoice_amount` (AmountCreateRequest, optional, nullable)
- `closed_invoice_amount` (AmountCreateRequest, optional, nullable)
- `paid_invoice_amount` (AmountCreateRequest, optional, nullable)
- `timezone` (string, optional, nullable)
- `billing_period` (PeriodCreateRequest, optional, nullable)
- `pricing_plan_subscription_ids` (list of string, optional, nullable)
- `pricing_plan_schedule_ids` (list of string, optional, nullable) — The pricing plan schedules this invoice bills for.
- `pricing_amount_type` (enum, optional) — Indicates whether the amounts provided, e.g. from the pricing plan, are including or excluding tax.
  - Allowed values: `EXCLUDING_TAX`, `INCLUDING_TAX`
- `periods` (list of InvoicePeriodCreateRequest, optional) — Periods that are applicable for this invoice, use either periods or groups for summation, groups will be removed in later version
- `closed_periods` (list of InvoicePeriodCreateRequest, optional, nullable)
- `tax_categories` (list of InvoiceTaxCategorySummaryCreateRequest, optional, nullable)
- `tax_summary` (InvoiceTaxTotalSummaryCreateRequest, optional, nullable)
- `dunning_actions` (list of InvoiceDunningActionCreateRequest, optional, nullable)
- `payment_acceptor_ids` (list of string, optional)
- `payment_actions` (list of InvoicePaymentActionCreateRequest, optional, nullable)
- `pay_invoice_link` (PortalUrlLinkCreateRequest, optional)
- `notes` (list of string, optional, nullable)
- `linked_invoices` (list of LinkedInvoiceDetailCreateRequest, optional, nullable)
- `custom_fields` (list of CustomFieldValueCreateRequest, optional, nullable)
- `other_custom_fields` (list of OtherCustomFieldValueCreateRequest, optional, nullable)
- `credit` (InvoiceCreditDetailCreateRequest, optional, nullable)
- `e_invoices` (list of EInvoiceCreateRequest, optional, nullable)
- `used_exchange_rates` (list of UsedExchangeRateCreateRequest, optional, nullable)
- `processing_only_customers` (list of CustomerCreateRequest, optional, nullable)
- `meter_values` (list of MeterValueCreateRequest, optional, nullable)
- `credit_types` (list of CreditTypeCreateRequest, optional, nullable)
- `meter_property_variables` (list of InvoiceMeterPropertyVariableCreateRequest, optional, nullable) — The meter property variables a pricing condition of this invoice was billed through, once each; their values are not included.
- `display_invoice_sub_lines_per_processing_only_customer` (boolean, optional, nullable)
- `show_original_customer_invoice_line` (boolean, optional, nullable)
- `show_tax_per_line_item` (boolean, optional, nullable)
- `forwarded_from_customers` (list of CustomerCreateRequest, optional, nullable)
- `validation_result` (list of InvoiceValidationResultCreateRequest, optional, nullable)
- `reprocess` (InvoiceReprocessCreateRequest, optional)
- `used_tax_registration` (TaxRegistrationCreateRequest, optional, nullable) — The tax registrations that are used to calculate the tax for this invoice. If empty, the billing entity was used
- `footnote` (string, optional, nullable) — Footnote to be shown on the invoice
- `approval_status` (enum, optional, nullable) — Approval status for invoices that are associated with an approval request
  - Allowed values: `PENDING_REVIEW`, `APPROVED`, `DECLINED`, `CANCELLED`
- `updated_to_final_at` (string, optional, nullable) — The invoice finalization date
- `has_usage_based_pricing` (boolean, optional, nullable)
- `coupons` (list of InvoiceCouponCreateRequest, optional, nullable) — Coupons applied to this invoice
- `promotion_codes` (list of InvoicePromotionCodeCreateRequest, optional, nullable) — Promotion codes applied to this invoice
- `linked_integrations` (list of LinkedIntegrationCreateRequest, optional, nullable)
- `billing_type` (enum, optional, nullable)
  - Allowed values: `DEFAULT`, `SELF_BILLING`
- `payment_status` (enum, optional, nullable)
  - Allowed values: `UNPAID`, `PARTIALLY_PAID`, `PAID`, `OVERPAID`
- `paid` (boolean, optional, nullable, deprecated)
- `auto_rescues` (list of InvoiceDunningActionCreateRequest, optional, nullable, deprecated)
- `linked_invoices_ids` (list of string, optional, deprecated) — Can currently only be used for 'ONE_OFF_CREDIT' invoices, indicates original invoices that this invoice links to
- `to_be_reprocessed` (boolean, optional, nullable, deprecated)
- `to_be_reprocessed_at` (string, optional, nullable, deprecated)

## Response

### 200

OK

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `invoice_number` (string, optional, nullable)
- `purchase_order_number` (string, optional, nullable)
- `platform_id` (string, optional, nullable)
- `customer_id` (string, optional, nullable) — id of the customer, can only be provided when creating a one-off invoice, and either id or reference is mandatory in that case
- `customer_reference` (string, optional, nullable) — reference of the customer, can only be provided when creating a one-off invoice, and either id or reference is mandatory in that case
- `sales_tax_percentage` (string, optional, nullable) — Sales tax percentage. Needs to be present if both customer and billing entity are US-based. Optional if one of them is US-based
- `customer` (Customer, optional, nullable)
- `billing_entity_id` (string, optional) — id of the billing entity, can only be provided for a one-off invoice. If not provided, the default of the platform will be used
- `billing_entity` (BillingEntity, optional, nullable)
- `status` (string, optional)
- `on_hold` (boolean, optional)
- `type` (enum, optional)
  - Allowed values: `STANDARD`, `CREDIT`, `ONE_OFF`, `ONE_OFF_CREDIT`
- `created_at` (string, optional, nullable)
- `updated_at` (string, optional, nullable)
- `invoice_date` (datetime, optional)
- `delivery_date` (string, optional, nullable)
- `due_date` (datetime, optional, nullable)
- `billing_period_date` (string, optional, nullable)
- `billing_currency` (string, optional, nullable)
- `invoice_amount_including_tax` (Amount, optional, nullable)
- `open_invoice_amount` (Amount, optional, nullable)
- `closed_invoice_amount` (Amount, optional, nullable)
- `paid_invoice_amount` (Amount, optional, nullable)
- `timezone` (string, optional, nullable)
- `billing_period` (Period, optional, nullable)
- `pricing_plan_subscription_ids` (list of string, optional, nullable)
- `pricing_plan_schedule_ids` (list of string, optional, nullable) — The pricing plan schedules this invoice bills for.
- `pricing_amount_type` (enum, optional) — Indicates whether the amounts provided, e.g. from the pricing plan, are including or excluding tax.
  - Allowed values: `EXCLUDING_TAX`, `INCLUDING_TAX`
- `periods` (list of InvoicePeriod, optional) — Periods that are applicable for this invoice, use either periods or groups for summation, groups will be removed in later version
- `closed_periods` (list of InvoicePeriod, optional, nullable)
- `tax_categories` (list of InvoiceTaxCategorySummary, optional, nullable)
- `tax_summary` (InvoiceTaxTotalSummary, optional, nullable)
- `dunning_actions` (list of InvoiceDunningAction, optional, nullable)
- `payment_acceptor_ids` (list of string, optional)
- `payment_actions` (list of InvoicePaymentAction, optional, nullable)
- `pay_invoice_link` (PortalUrlLink, optional)
- `notes` (list of string, optional, nullable)
- `linked_invoices` (list of LinkedInvoiceDetail, optional, nullable)
- `custom_fields` (list of CustomFieldValue, optional, nullable)
- `other_custom_fields` (list of OtherCustomFieldValue, optional, nullable)
- `credit` (InvoiceCreditDetail, optional, nullable)
- `e_invoices` (list of EInvoice, optional, nullable)
- `used_exchange_rates` (list of UsedExchangeRate, optional, nullable)
- `processing_only_customers` (list of Customer, optional, nullable)
- `meter_values` (list of MeterValue, optional, nullable)
- `credit_types` (list of CreditType, optional, nullable)
- `meter_property_variables` (list of InvoiceMeterPropertyVariable, optional, nullable) — The meter property variables a pricing condition of this invoice was billed through, once each; their values are not included.
- `display_invoice_sub_lines_per_processing_only_customer` (boolean, optional, nullable)
- `show_original_customer_invoice_line` (boolean, optional, nullable)
- `show_tax_per_line_item` (boolean, optional, nullable)
- `forwarded_from_customers` (list of Customer, optional, nullable)
- `validation_result` (list of InvoiceValidationResult, optional, nullable)
- `reprocess` (InvoiceReprocess, optional)
- `used_tax_registration` (TaxRegistration, optional, nullable) — The tax registrations that are used to calculate the tax for this invoice. If empty, the billing entity was used
- `footnote` (string, optional, nullable) — Footnote to be shown on the invoice
- `approval_status` (enum, optional, nullable) — Approval status for invoices that are associated with an approval request
  - Allowed values: `PENDING_REVIEW`, `APPROVED`, `DECLINED`, `CANCELLED`
- `updated_to_final_at` (string, optional, nullable) — The invoice finalization date
- `has_usage_based_pricing` (boolean, optional, nullable)
- `coupons` (list of InvoiceCoupon, optional, nullable) — Coupons applied to this invoice
- `promotion_codes` (list of InvoicePromotionCode, optional, nullable) — Promotion codes applied to this invoice
- `linked_integrations` (list of LinkedIntegration, optional, nullable)
- `billing_type` (enum, optional, nullable)
  - Allowed values: `DEFAULT`, `SELF_BILLING`
- `payment_status` (enum, optional, nullable)
  - Allowed values: `UNPAID`, `PARTIALLY_PAID`, `PAID`, `OVERPAID`
- `paid` (boolean, optional, nullable, deprecated)
- `auto_rescues` (list of InvoiceDunningAction, optional, nullable, deprecated)
- `linked_invoices_ids` (list of string, optional, deprecated) — Can currently only be used for 'ONE_OFF_CREDIT' invoices, indicates original invoices that this invoice links to
- `to_be_reprocessed` (boolean, optional, nullable, deprecated)
- `to_be_reprocessed_at` (string, optional, nullable, deprecated)

## Errors

### 400 Bad Request Error

Bad Request

- `type` (enum, required)
  - Allowed values: `API_ERROR`, `INVALID_REQUEST`
- `code` (enum, required)
  - Allowed values: `RESOURCE_NOT_FOUND`, `RESOURCES_NOT_FOUND`, `UNABLE_TO_PROCESS_INSTRUCTIONS`, `BAD_REQUEST`, `UNSUPPORTED_MEDIA_TYPE`, `RESOURCE_ALREADY_EXISTS`, `CUSTOM_FIELD_VALUE_ALREADY_EXISTS`, `COULD_NOT_CREATE_RESOURCE`, `COULD_NOT_UPDATE_RESOURCE`, `COULD_NOT_DELETE_RESOURCE`, `MISSING_VERSION`, `UNSUPPORTED_VERSION`, `UNAUTHORISED`, `CUSTOMER_NOT_FOUND`, `PLATFORM_NOT_FOUND`, `PRICING_PLAN_NOT_FOUND`, `PRODUCT_NOT_FOUND`, `PRODUCT_ITEM_NOT_FOUND`, `PRICING_NOT_FOUND`, `PRICING_ITEM_NOT_FOUND`, `USER_NOT_FOUND`, `METER_NOT_FOUND`, `METER_VALUE_NOT_FOUND`, `METER_PROPERTY_NOT_FOUND`, `PRICING_ITEM_SUMMARIES_NOT_FOUND`, `MISSING_ID`, `INVALID_ID`, `MISSING_REFERENCE`, `MISSING_FIELD`, `INVALID_FIELD`, `INVALID_OPERATION`, `INTERNAL_ERROR`, `USER_NOT_ALLOWED`, `IDEMPOTENCY_CHECK_FAILED`, `INVALID_REQUEST`
- `message` (string, required)
- `field` (string, optional, nullable)
- `resource_id` (string, optional, nullable)
- `resource_type` (enum, optional, nullable)
  - Allowed values: `CUSTOMER`, `CUSTOM_FIELD`, `PLATFORM`, `PLATFORM_UPTODATE`, `METER`, `METER_VALUE`, `METER_PROPERTY`, `METER_PROPERTY_VARIABLE`, `METER_VALUE_CALCULATION`, `INGEST_DATA`, `METER_DATA`, `CHARGE_DATA`, `PERSIST_DATA`, `ADJUSTMENT_DATA`, `PRODUCT_CATEGORY`, `PRODUCT`, `PRODUCT_ITEM`, `PRICING`, `PRICING_GROUP`, `PRICING_ITEM`, `PRICING_ITEM_CONFIG`, `PRICING_PLAN_SUBSCRIPTION`, `PRICING_PLAN_SUBSCRIPTION_GROUP`, `PRICING_PLAN_SCHEDULE`, `SEAT_ASSIGNMENT`, `SHIPPING_ADDRESS`, `PRICING_PLAN`, `PRICING_PLAN_VERSION`, `PRICING_PLAN_GROUP`, `QUOTE`, `QUOTE_VERSION`, `QUOTE_TEMPLATE`, `QUOTE_VERSION_SUMMARY`, `API_KEY`, `USER`, `ROLE`, `PROXY_USER`, `EXTERNAL_CREDENTIALS`, `TOKEN`, `INVOICE`, `E_INVOICE`, `PDF`, `BILLING_ENTITY`, `FEATURE`, `MEMBERSHIP`, `PAYMENT`, `PAYMENT_ACCEPTOR`, `PAYMENT_METHOD`, `PAYMENT_METHOD_OPTIONS`, `PAYMENT_SCHEDULE`, `PAYMENT_REQUEST`, `INTEGRATION`, `WEBHOOK`, `WEBHOOK_EVENT`, `FILE`, `FILE_PROCESSING_SETTINGS`, `TEAM`, `DOWNLOAD_URL`, `CSV_REPORT`, `REPORT`, `REPORT_GENERATE_REQUEST`, `REPORT_CONFIGURATION`, `REPORT_SUBSCRIPTION`, `REPORT_DEFINITION`, `ACCOUNT_GROUP`, `ENTITY`, `EVENT_TRACE`, `EVENT_TRACE_LINK`, `PRICING_CATEGORY`, `CONTACT`, `ALERT_RULE`, `ALERT`, `USAGE_LIMIT`, `AUDIT_RECORD`, `PORTAL_URL`, `AUTHENTICATION_PROVIDER`, `REPROCESS`, `APPROVAL_POLICY`, `APPROVAL_REQUEST`, `BULK_ACTION`, `COUPON`, `PROMOTION_CODE`, `WALLET`, `WALLET_TYPE`, `WALLET_GRANT`, `AUTO_TOPUP_CONFIG`, `WORKFLOW`, `WORKFLOW_TRIGGER`, `WORKFLOW_ACTION`, `WORKFLOW_ACTION_EXECUTION`, `CREDIT_TYPE`, `SIGNATURE_REQUEST`, `ATTACHMENT`, `DOCUMENT`, `EXCHANGE_RATE`

### 401 Unauthorized Error

Unauthorized

- `type` (enum, required)
  - Allowed values: `API_ERROR`, `INVALID_REQUEST`
- `code` (enum, required)
  - Allowed values: `RESOURCE_NOT_FOUND`, `RESOURCES_NOT_FOUND`, `UNABLE_TO_PROCESS_INSTRUCTIONS`, `BAD_REQUEST`, `UNSUPPORTED_MEDIA_TYPE`, `RESOURCE_ALREADY_EXISTS`, `CUSTOM_FIELD_VALUE_ALREADY_EXISTS`, `COULD_NOT_CREATE_RESOURCE`, `COULD_NOT_UPDATE_RESOURCE`, `COULD_NOT_DELETE_RESOURCE`, `MISSING_VERSION`, `UNSUPPORTED_VERSION`, `UNAUTHORISED`, `CUSTOMER_NOT_FOUND`, `PLATFORM_NOT_FOUND`, `PRICING_PLAN_NOT_FOUND`, `PRODUCT_NOT_FOUND`, `PRODUCT_ITEM_NOT_FOUND`, `PRICING_NOT_FOUND`, `PRICING_ITEM_NOT_FOUND`, `USER_NOT_FOUND`, `METER_NOT_FOUND`, `METER_VALUE_NOT_FOUND`, `METER_PROPERTY_NOT_FOUND`, `PRICING_ITEM_SUMMARIES_NOT_FOUND`, `MISSING_ID`, `INVALID_ID`, `MISSING_REFERENCE`, `MISSING_FIELD`, `INVALID_FIELD`, `INVALID_OPERATION`, `INTERNAL_ERROR`, `USER_NOT_ALLOWED`, `IDEMPOTENCY_CHECK_FAILED`, `INVALID_REQUEST`
- `message` (string, required)
- `field` (string, optional, nullable)
- `resource_id` (string, optional, nullable)
- `resource_type` (enum, optional, nullable)
  - Allowed values: `CUSTOMER`, `CUSTOM_FIELD`, `PLATFORM`, `PLATFORM_UPTODATE`, `METER`, `METER_VALUE`, `METER_PROPERTY`, `METER_PROPERTY_VARIABLE`, `METER_VALUE_CALCULATION`, `INGEST_DATA`, `METER_DATA`, `CHARGE_DATA`, `PERSIST_DATA`, `ADJUSTMENT_DATA`, `PRODUCT_CATEGORY`, `PRODUCT`, `PRODUCT_ITEM`, `PRICING`, `PRICING_GROUP`, `PRICING_ITEM`, `PRICING_ITEM_CONFIG`, `PRICING_PLAN_SUBSCRIPTION`, `PRICING_PLAN_SUBSCRIPTION_GROUP`, `PRICING_PLAN_SCHEDULE`, `SEAT_ASSIGNMENT`, `SHIPPING_ADDRESS`, `PRICING_PLAN`, `PRICING_PLAN_VERSION`, `PRICING_PLAN_GROUP`, `QUOTE`, `QUOTE_VERSION`, `QUOTE_TEMPLATE`, `QUOTE_VERSION_SUMMARY`, `API_KEY`, `USER`, `ROLE`, `PROXY_USER`, `EXTERNAL_CREDENTIALS`, `TOKEN`, `INVOICE`, `E_INVOICE`, `PDF`, `BILLING_ENTITY`, `FEATURE`, `MEMBERSHIP`, `PAYMENT`, `PAYMENT_ACCEPTOR`, `PAYMENT_METHOD`, `PAYMENT_METHOD_OPTIONS`, `PAYMENT_SCHEDULE`, `PAYMENT_REQUEST`, `INTEGRATION`, `WEBHOOK`, `WEBHOOK_EVENT`, `FILE`, `FILE_PROCESSING_SETTINGS`, `TEAM`, `DOWNLOAD_URL`, `CSV_REPORT`, `REPORT`, `REPORT_GENERATE_REQUEST`, `REPORT_CONFIGURATION`, `REPORT_SUBSCRIPTION`, `REPORT_DEFINITION`, `ACCOUNT_GROUP`, `ENTITY`, `EVENT_TRACE`, `EVENT_TRACE_LINK`, `PRICING_CATEGORY`, `CONTACT`, `ALERT_RULE`, `ALERT`, `USAGE_LIMIT`, `AUDIT_RECORD`, `PORTAL_URL`, `AUTHENTICATION_PROVIDER`, `REPROCESS`, `APPROVAL_POLICY`, `APPROVAL_REQUEST`, `BULK_ACTION`, `COUPON`, `PROMOTION_CODE`, `WALLET`, `WALLET_TYPE`, `WALLET_GRANT`, `AUTO_TOPUP_CONFIG`, `WORKFLOW`, `WORKFLOW_TRIGGER`, `WORKFLOW_ACTION`, `WORKFLOW_ACTION_EXECUTION`, `CREDIT_TYPE`, `SIGNATURE_REQUEST`, `ATTACHMENT`, `DOCUMENT`, `EXCHANGE_RATE`

### 403 Forbidden Error

Forbidden

- `type` (enum, required)
  - Allowed values: `API_ERROR`, `INVALID_REQUEST`
- `code` (enum, required)
  - Allowed values: `RESOURCE_NOT_FOUND`, `RESOURCES_NOT_FOUND`, `UNABLE_TO_PROCESS_INSTRUCTIONS`, `BAD_REQUEST`, `UNSUPPORTED_MEDIA_TYPE`, `RESOURCE_ALREADY_EXISTS`, `CUSTOM_FIELD_VALUE_ALREADY_EXISTS`, `COULD_NOT_CREATE_RESOURCE`, `COULD_NOT_UPDATE_RESOURCE`, `COULD_NOT_DELETE_RESOURCE`, `MISSING_VERSION`, `UNSUPPORTED_VERSION`, `UNAUTHORISED`, `CUSTOMER_NOT_FOUND`, `PLATFORM_NOT_FOUND`, `PRICING_PLAN_NOT_FOUND`, `PRODUCT_NOT_FOUND`, `PRODUCT_ITEM_NOT_FOUND`, `PRICING_NOT_FOUND`, `PRICING_ITEM_NOT_FOUND`, `USER_NOT_FOUND`, `METER_NOT_FOUND`, `METER_VALUE_NOT_FOUND`, `METER_PROPERTY_NOT_FOUND`, `PRICING_ITEM_SUMMARIES_NOT_FOUND`, `MISSING_ID`, `INVALID_ID`, `MISSING_REFERENCE`, `MISSING_FIELD`, `INVALID_FIELD`, `INVALID_OPERATION`, `INTERNAL_ERROR`, `USER_NOT_ALLOWED`, `IDEMPOTENCY_CHECK_FAILED`, `INVALID_REQUEST`
- `message` (string, required)
- `field` (string, optional, nullable)
- `resource_id` (string, optional, nullable)
- `resource_type` (enum, optional, nullable)
  - Allowed values: `CUSTOMER`, `CUSTOM_FIELD`, `PLATFORM`, `PLATFORM_UPTODATE`, `METER`, `METER_VALUE`, `METER_PROPERTY`, `METER_PROPERTY_VARIABLE`, `METER_VALUE_CALCULATION`, `INGEST_DATA`, `METER_DATA`, `CHARGE_DATA`, `PERSIST_DATA`, `ADJUSTMENT_DATA`, `PRODUCT_CATEGORY`, `PRODUCT`, `PRODUCT_ITEM`, `PRICING`, `PRICING_GROUP`, `PRICING_ITEM`, `PRICING_ITEM_CONFIG`, `PRICING_PLAN_SUBSCRIPTION`, `PRICING_PLAN_SUBSCRIPTION_GROUP`, `PRICING_PLAN_SCHEDULE`, `SEAT_ASSIGNMENT`, `SHIPPING_ADDRESS`, `PRICING_PLAN`, `PRICING_PLAN_VERSION`, `PRICING_PLAN_GROUP`, `QUOTE`, `QUOTE_VERSION`, `QUOTE_TEMPLATE`, `QUOTE_VERSION_SUMMARY`, `API_KEY`, `USER`, `ROLE`, `PROXY_USER`, `EXTERNAL_CREDENTIALS`, `TOKEN`, `INVOICE`, `E_INVOICE`, `PDF`, `BILLING_ENTITY`, `FEATURE`, `MEMBERSHIP`, `PAYMENT`, `PAYMENT_ACCEPTOR`, `PAYMENT_METHOD`, `PAYMENT_METHOD_OPTIONS`, `PAYMENT_SCHEDULE`, `PAYMENT_REQUEST`, `INTEGRATION`, `WEBHOOK`, `WEBHOOK_EVENT`, `FILE`, `FILE_PROCESSING_SETTINGS`, `TEAM`, `DOWNLOAD_URL`, `CSV_REPORT`, `REPORT`, `REPORT_GENERATE_REQUEST`, `REPORT_CONFIGURATION`, `REPORT_SUBSCRIPTION`, `REPORT_DEFINITION`, `ACCOUNT_GROUP`, `ENTITY`, `EVENT_TRACE`, `EVENT_TRACE_LINK`, `PRICING_CATEGORY`, `CONTACT`, `ALERT_RULE`, `ALERT`, `USAGE_LIMIT`, `AUDIT_RECORD`, `PORTAL_URL`, `AUTHENTICATION_PROVIDER`, `REPROCESS`, `APPROVAL_POLICY`, `APPROVAL_REQUEST`, `BULK_ACTION`, `COUPON`, `PROMOTION_CODE`, `WALLET`, `WALLET_TYPE`, `WALLET_GRANT`, `AUTO_TOPUP_CONFIG`, `WORKFLOW`, `WORKFLOW_TRIGGER`, `WORKFLOW_ACTION`, `WORKFLOW_ACTION_EXECUTION`, `CREDIT_TYPE`, `SIGNATURE_REQUEST`, `ATTACHMENT`, `DOCUMENT`, `EXCHANGE_RATE`

### 500 Internal Server Error

Internal Server Error

- `type` (enum, required)
  - Allowed values: `API_ERROR`, `INVALID_REQUEST`
- `code` (enum, required)
  - Allowed values: `RESOURCE_NOT_FOUND`, `RESOURCES_NOT_FOUND`, `UNABLE_TO_PROCESS_INSTRUCTIONS`, `BAD_REQUEST`, `UNSUPPORTED_MEDIA_TYPE`, `RESOURCE_ALREADY_EXISTS`, `CUSTOM_FIELD_VALUE_ALREADY_EXISTS`, `COULD_NOT_CREATE_RESOURCE`, `COULD_NOT_UPDATE_RESOURCE`, `COULD_NOT_DELETE_RESOURCE`, `MISSING_VERSION`, `UNSUPPORTED_VERSION`, `UNAUTHORISED`, `CUSTOMER_NOT_FOUND`, `PLATFORM_NOT_FOUND`, `PRICING_PLAN_NOT_FOUND`, `PRODUCT_NOT_FOUND`, `PRODUCT_ITEM_NOT_FOUND`, `PRICING_NOT_FOUND`, `PRICING_ITEM_NOT_FOUND`, `USER_NOT_FOUND`, `METER_NOT_FOUND`, `METER_VALUE_NOT_FOUND`, `METER_PROPERTY_NOT_FOUND`, `PRICING_ITEM_SUMMARIES_NOT_FOUND`, `MISSING_ID`, `INVALID_ID`, `MISSING_REFERENCE`, `MISSING_FIELD`, `INVALID_FIELD`, `INVALID_OPERATION`, `INTERNAL_ERROR`, `USER_NOT_ALLOWED`, `IDEMPOTENCY_CHECK_FAILED`, `INVALID_REQUEST`
- `message` (string, required)
- `field` (string, optional, nullable)
- `resource_id` (string, optional, nullable)
- `resource_type` (enum, optional, nullable)
  - Allowed values: `CUSTOMER`, `CUSTOM_FIELD`, `PLATFORM`, `PLATFORM_UPTODATE`, `METER`, `METER_VALUE`, `METER_PROPERTY`, `METER_PROPERTY_VARIABLE`, `METER_VALUE_CALCULATION`, `INGEST_DATA`, `METER_DATA`, `CHARGE_DATA`, `PERSIST_DATA`, `ADJUSTMENT_DATA`, `PRODUCT_CATEGORY`, `PRODUCT`, `PRODUCT_ITEM`, `PRICING`, `PRICING_GROUP`, `PRICING_ITEM`, `PRICING_ITEM_CONFIG`, `PRICING_PLAN_SUBSCRIPTION`, `PRICING_PLAN_SUBSCRIPTION_GROUP`, `PRICING_PLAN_SCHEDULE`, `SEAT_ASSIGNMENT`, `SHIPPING_ADDRESS`, `PRICING_PLAN`, `PRICING_PLAN_VERSION`, `PRICING_PLAN_GROUP`, `QUOTE`, `QUOTE_VERSION`, `QUOTE_TEMPLATE`, `QUOTE_VERSION_SUMMARY`, `API_KEY`, `USER`, `ROLE`, `PROXY_USER`, `EXTERNAL_CREDENTIALS`, `TOKEN`, `INVOICE`, `E_INVOICE`, `PDF`, `BILLING_ENTITY`, `FEATURE`, `MEMBERSHIP`, `PAYMENT`, `PAYMENT_ACCEPTOR`, `PAYMENT_METHOD`, `PAYMENT_METHOD_OPTIONS`, `PAYMENT_SCHEDULE`, `PAYMENT_REQUEST`, `INTEGRATION`, `WEBHOOK`, `WEBHOOK_EVENT`, `FILE`, `FILE_PROCESSING_SETTINGS`, `TEAM`, `DOWNLOAD_URL`, `CSV_REPORT`, `REPORT`, `REPORT_GENERATE_REQUEST`, `REPORT_CONFIGURATION`, `REPORT_SUBSCRIPTION`, `REPORT_DEFINITION`, `ACCOUNT_GROUP`, `ENTITY`, `EVENT_TRACE`, `EVENT_TRACE_LINK`, `PRICING_CATEGORY`, `CONTACT`, `ALERT_RULE`, `ALERT`, `USAGE_LIMIT`, `AUDIT_RECORD`, `PORTAL_URL`, `AUTHENTICATION_PROVIDER`, `REPROCESS`, `APPROVAL_POLICY`, `APPROVAL_REQUEST`, `BULK_ACTION`, `COUPON`, `PROMOTION_CODE`, `WALLET`, `WALLET_TYPE`, `WALLET_GRANT`, `AUTO_TOPUP_CONFIG`, `WORKFLOW`, `WORKFLOW_TRIGGER`, `WORKFLOW_ACTION`, `WORKFLOW_ACTION_EXECUTION`, `CREDIT_TYPE`, `SIGNATURE_REQUEST`, `ATTACHMENT`, `DOCUMENT`, `EXCHANGE_RATE`

## Types

### CustomerCreateRequest

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `created_at` (string, optional, nullable)
- `parent_customer_id` (string, optional, nullable) — The parent of the customer. Only returned when there is a single parent.
- `parent_customer_ids` (list of string, optional, nullable) — A list of parents of the customer. Will also be returned if there is a single parent.
- `reference` (string, optional) — A custom reference assigned to the customer.
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`, `CLOSED`
- `timezone` (string, optional, nullable)
- `type` (enum, optional) — The type of customer entity.
  - Allowed values: `ORGANIZATION`, `INDIVIDUAL`
- `email` (string, optional, nullable) — The email of the customer.
- `notification_preferences` (list of NotificationPreference, optional, nullable) — Notification preferences for customer-related communications.
- `locale` (string, optional, nullable) — The locale of the customer. Format is language-country (like en-US).
- `individual` (Individual, optional) — Additional description of the individual customer type.
- `organization` (Organization, optional) — Additional description of the organization customer type.
- `custom_fields` (list of CustomFieldValue, optional, nullable)
- `pricing_plan_subscription_selector` (PricingPlanSubscriptionSelector, optional) — Settings to influence dynamically the subscription to use for the ingest data.
- `linked_integrations` (list of LinkedIntegration, optional, nullable)
- `roles` (list of enum, optional, nullable)
  - Allowed values: `DEFAULT`, `NON_PROCESSING`, `SELF_BILLING`, `SELLER`, `PROCESSING_ONLY`
- `seller_details` (CustomerSellerDetails, optional)
- `processing_only` (boolean, optional, nullable, deprecated)

### BillingEntityCreateRequest

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `created_at` (string, optional, nullable)
- `reference` (string, optional)
- `status` (string, optional, nullable)
- `timezone` (string, optional, nullable)
- `legal_name` (string, optional, nullable) — The legal name of the billing entity.
- `tax_id` (string, optional, nullable) — The ID used for tax purposes of the billing entity.
- `tax_ids` (list of TaxId, optional, nullable) — Tax IDs used for tax purposes of the billing entity
- `registration_number` (string, optional, nullable) — The registration number of the billing entity.
- `registered_address` (Address, optional) — The address associated with the billing entity.
- `email` (string, optional, nullable) — The email address of the billing entity.
- `tax_settings` (TaxSettings, optional) — Customise tax settings for this Billing Entity
- `tax_registrations` (list of TaxRegistration, optional, nullable) — Extra tax registrations for this billing entity
- `custom_fields` (list of CustomFieldValue, optional, nullable)
- `default_customer_country_selector` (list of enum, optional, nullable)
  - Allowed values: `AD`, `AE`, `AF`, `AG`, `AI`, `AL`, `AM`, `AO`, `AQ`, `AR`, `AS`, `AT`, `AU`, `AW`, `AX`, `AZ`, `BA`, `BB`, `BD`, `BE`, `BF`, `BG`, `BH`, `BI`, `BJ`, `BL`, `BM`, `BN`, `BO`, `BQ`, `BR`, `BS`, `BT`, `BV`, `BW`, `BY`, `BZ`, `CA`, `CC`, `CD`, `CF`, `CG`, `CH`, `CI`, `CK`, `CL`, `CM`, `CN`, `CO`, `CR`, `CU`, `CV`, `CW`, `CX`, `CY`, `CZ`, `DE`, `DJ`, `DK`, `DM`, `DO`, `DZ`, `EC`, `EE`, `EG`, `EH`, `ER`, `ES`, `ET`, `FI`, `FJ`, `FK`, `FM`, `FO`, `FR`, `GA`, `GB`, `GD`, `GE`, `GF`, `GG`, `GH`, `GI`, `GL`, `GM`, `GN`, `GP`, `GQ`, `GR`, `GS`, `GT`, `GU`, `GW`, `GY`, `HK`, `HM`, `HN`, `HR`, `HT`, `HU`, `ID`, `IE`, `IL`, `IM`, `IN`, `IO`, `IQ`, `IR`, `IS`, `IT`, `JE`, `JM`, `JO`, `JP`, `KE`, `KG`, `KH`, `KI`, `KM`, `KN`, `KP`, `KR`, `KW`, `KY`, `KZ`, `LA`, `LB`, `LC`, `LI`, `LK`, `LR`, `LS`, `LT`, `LU`, `LV`, `LY`, `MA`, `MC`, `MD`, `ME`, `MF`, `MG`, `MH`, `MK`, `ML`, `MM`, `MN`, `MO`, `MP`, `MQ`, `MR`, `MS`, `MT`, `MU`, `MV`, `MW`, `MX`, `MY`, `MZ`, `NA`, `NC`, `NE`, `NF`, `NG`, `NI`, `NL`, `NO`, `NP`, `NR`, `NU`, `NZ`, `OM`, `PA`, `PE`, `PF`, `PG`, `PH`, `PK`, `PL`, `PM`, `PN`, `PR`, `PS`, `PT`, `PW`, `PY`, `QA`, `RE`, `RO`, `RS`, `RU`, `RW`, `SA`, `SB`, `SC`, `SD`, `SE`, `SG`, `SH`, `SI`, `SJ`, `SK`, `SL`, `SM`, `SN`, `SO`, `SR`, `SS`, `ST`, `SV`, `SX`, `SY`, `SZ`, `TC`, `TD`, `TF`, `TG`, `TH`, `TJ`, `TK`, `TL`, `TM`, `TN`, `TO`, `TR`, `TT`, `TV`, `TW`, `TZ`, `UA`, `UG`, `US`, `UY`, `UZ`, `VA`, `VC`, `VE`, `VG`, `VI`, `VN`, `VU`, `WF`, `WS`, `YE`, `YT`, `ZA`, `ZM`, `ZW`
- `default_billing_currency_selector` (list of enum, optional, nullable)
  - Allowed values: `AED`, `AFN`, `ALL`, `AMD`, `ANG`, `AOA`, `ARS`, `AUD`, `AWG`, `AZN`, `BAM`, `BBD`, `BDT`, `BGN`, `BHD`, `BIF`, `BMD`, `BND`, `BOB`, `BRL`, `BSD`, `BTN`, `BWP`, `BYN`, `BZD`, `CAD`, `CDF`, `CHF`, `CLF`, `CLP`, `CNY`, `COP`, `CRC`, `CUC`, `CUP`, `CVE`, `CZK`, `DJF`, `DKK`, `DOP`, `DZD`, `EGP`, `ERN`, `ETB`, `EUR`, `FJD`, `FKP`, `GBP`, `GEL`, `GHS`, `GIP`, `GMD`, `GNF`, `GTQ`, `GYD`, `HKD`, `HNL`, `HRK`, `HTG`, `HUF`, `IDR`, `ILS`, `INR`, `IQD`, `IRR`, `ISK`, `JMD`, `JOD`, `JPY`, `KES`, `KGS`, `KHR`, `KMF`, `KPW`, `KRW`, `KWD`, `KYD`, `KZT`, `LAK`, `LBP`, `LKR`, `LRD`, `LSL`, `LYD`, `MAD`, `MDL`, `MGA`, `MKD`, `MMK`, `MNT`, `MOP`, `MRO`, `MRU`, `MUR`, `MVR`, `MWK`, `MXN`, `MXV`, `MYR`, `MZN`, `NAD`, `NGN`, `NIO`, `NOK`, `NPR`, `NZD`, `OMR`, `PAB`, `PEN`, `PGK`, `PHP`, `PKR`, `PLN`, `PYG`, `QAR`, `RON`, `RSD`, `RUB`, `RWF`, `SAR`, `SBD`, `SCR`, `SDG`, `SEK`, `SGD`, `SHP`, `SLE`, `SOS`, `SRD`, `SSP`, `STN`, `SVC`, `SYP`, `SZL`, `THB`, `TJS`, `TMT`, `TND`, `TOP`, `TRY`, `TTD`, `TWD`, `TZS`, `UAH`, `UGX`, `USD`, `USN`, `UYI`, `UYU`, `UZS`, `VEF`, `VES`, `VND`, `VUV`, `WST`, `XAF`, `XAG`, `XAU`, `XBA`, `XBB`, `XBC`, `XBD`, `XCD`, `XDR`, `XOF`, `XPD`, `XPF`, `XPT`, `XSU`, `XTS`, `XUA`, `XXX`, `YER`, `ZAR`, `ZMW`, `ZWL`
- `linked_integrations` (list of LinkedIntegration, optional, nullable)

### AmountCreateRequest

- `quantity` (string, optional)
- `currency` (enum, optional)
  - Allowed values: `AED`, `AFN`, `ALL`, `AMD`, `ANG`, `AOA`, `ARS`, `AUD`, `AWG`, `AZN`, `BAM`, `BBD`, `BDT`, `BGN`, `BHD`, `BIF`, `BMD`, `BND`, `BOB`, `BRL`, `BSD`, `BTN`, `BWP`, `BYN`, `BZD`, `CAD`, `CDF`, `CHF`, `CLF`, `CLP`, `CNY`, `COP`, `CRC`, `CUC`, `CUP`, `CVE`, `CZK`, `DJF`, `DKK`, `DOP`, `DZD`, `EGP`, `ERN`, `ETB`, `EUR`, `FJD`, `FKP`, `GBP`, `GEL`, `GHS`, `GIP`, `GMD`, `GNF`, `GTQ`, `GYD`, `HKD`, `HNL`, `HRK`, `HTG`, `HUF`, `IDR`, `ILS`, `INR`, `IQD`, `IRR`, `ISK`, `JMD`, `JOD`, `JPY`, `KES`, `KGS`, `KHR`, `KMF`, `KPW`, `KRW`, `KWD`, `KYD`, `KZT`, `LAK`, `LBP`, `LKR`, `LRD`, `LSL`, `LYD`, `MAD`, `MDL`, `MGA`, `MKD`, `MMK`, `MNT`, `MOP`, `MRO`, `MRU`, `MUR`, `MVR`, `MWK`, `MXN`, `MXV`, `MYR`, `MZN`, `NAD`, `NGN`, `NIO`, `NOK`, `NPR`, `NZD`, `OMR`, `PAB`, `PEN`, `PGK`, `PHP`, `PKR`, `PLN`, `PYG`, `QAR`, `RON`, `RSD`, `RUB`, `RWF`, `SAR`, `SBD`, `SCR`, `SDG`, `SEK`, `SGD`, `SHP`, `SLE`, `SOS`, `SRD`, `SSP`, `STN`, `SVC`, `SYP`, `SZL`, `THB`, `TJS`, `TMT`, `TND`, `TOP`, `TRY`, `TTD`, `TWD`, `TZS`, `UAH`, `UGX`, `USD`, `USN`, `UYI`, `UYU`, `UZS`, `VEF`, `VES`, `VND`, `VUV`, `WST`, `XAF`, `XAG`, `XAU`, `XBA`, `XBB`, `XBC`, `XBD`, `XCD`, `XDR`, `XOF`, `XPD`, `XPF`, `XPT`, `XSU`, `XTS`, `XUA`, `XXX`, `YER`, `ZAR`, `ZMW`, `ZWL`

### PeriodCreateRequest

- `type` (enum, optional)
  - Allowed values: `DAY`, `WEEK`, `MONTH`, `YEAR`
- `value` (integer, optional, nullable)

### InvoicePeriodCreateRequest

- `period_order` (integer, optional)
- `amount_excluding_tax` (Amount, optional)
- `amount_including_tax` (Amount, optional)
- `billing_period` (Period, optional)
- `start_at` (string, optional)
- `end_at` (string, optional)
- `tax_categories` (list of InvoiceTaxCategorySummary, optional)
- `groups` (list of InvoiceGroup, optional, nullable)

### InvoiceTaxCategorySummaryCreateRequest

- `base_amount` (Amount, optional)
- `tax_amount` (Amount, optional)
- `total_amount` (Amount, optional)
- `category` (string, optional)
- `local_amounts` (InvoiceTaxAmounts, optional)
- `notes` (list of string, optional, nullable)
- `rates` (list of InvoiceTaxCategorySummaryRate, optional, nullable)
- `percentage` (string, optional, deprecated)
- `name` (string, optional, deprecated)

### InvoiceTaxTotalSummaryCreateRequest

- `base_amount` (Amount, optional)
- `tax_amount` (Amount, optional)
- `total_amount` (Amount, optional)
- `local_amounts` (InvoiceTaxAmounts, optional)
- `notes` (list of string, optional, nullable)
- `country_code` (string, optional)

### InvoiceDunningActionCreateRequest

- `payment_acceptor_id` (string, optional) — Resource ID of type PAYMENT_ACCEPTOR
- `external_reference` (string, optional)
- `status` (enum, optional)
  - Allowed values: `CANCEL_PENDING`, `CANCELLED`, `FAILED`, `PENDING`, `SUCCESSFUL`
- `failure_reason` (string, optional, nullable)
- `first_payment_id` (string, optional, nullable) — Resource ID of type PAYMENT

### InvoicePaymentActionCreateRequest

- `payment_acceptor_id` (string, optional)
- `payment_acceptor` (PaymentAcceptor, optional, nullable)
- `type` (string, optional)
- `bank_account` (InvoicePaymentActionBankAccountDetails, optional)
- `payment_gateway` (InvoicePaymentActionPaymentGatewayDetails, optional)
- `custom_redirect` (InvoicePaymentActionCustomRedirectDetails, optional)

### PortalUrlLinkCreateRequest

- `expiry_period` (PortalUrlPeriod, optional, nullable)
- `portal_url_id` (string, optional, nullable) — Resource ID of type PORTAL_URL
- `url` (string, optional, nullable)

### LinkedInvoiceDetailCreateRequest

- `id` (string, optional)
- `link_type` (string, optional)
- `note` (string, optional, nullable)
- `invoice_number` (string, optional, nullable)
- `amount` (Amount, optional)
- `invoice_date` (string, optional, nullable)

### CustomFieldValueCreateRequest

- `id` (string, optional, nullable) — Resource ID of type CUSTOM_FIELD
- `reference` (string, optional, nullable)
- `value` (string, optional, nullable)
- `values` (list of string, optional, nullable)
- `integration_details` (IntegrationDetails, optional, nullable)
- `integration_id` (string, optional) — The resource ID of the integration linked to the custom field

### OtherCustomFieldValueCreateRequest

- `resource` (ResourceIdentifier, optional)
- `id` (string, optional)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `value` (string, optional, nullable)
- `values` (list of string, optional, nullable)

### InvoiceCreditDetailCreateRequest

- `original_invoice_info` (OriginalInvoiceInfo, optional)
- `note` (string, optional)
- `credit_details_source` (enum, optional, nullable) — Source of customer and billing entity information on credit invoices, CURRENT by default.
  - Allowed values: `CURRENT`, `ORIGINAL`
- `original_invoice_id` (string, optional, deprecated)

### EInvoiceCreateRequest

- `external_reference` (string, optional, nullable) — The external reference that's used to identify this eInvoice with the eInvoicing integration
- `applied_mandate` (string, optional) — The mandate that was applied to this eInvoice
- `processor` (string, optional) — The eInvoicing integration that processed this eInvoice
- `status` (EInvoiceStatus, optional)
- `status_history` (list of EInvoiceStatus, optional)
- `supported_file_formats` (list of EInvoiceFileFormat, optional) — The file formats in which this eInvoice can be downloaded

### UsedExchangeRateCreateRequest

- `currency` (string, optional)
- `base_currency` (string, optional)
- `rate_timestamp` (string, optional)
- `rate` (string, optional)
- `source` (string, optional, nullable)

### MeterValueCreateRequest

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `status` (enum, optional, nullable) — The status of the meter value indicating the activity and the ability to update properties.
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `type` (enum, optional, nullable) — The type of the meter value.
  - Allowed values: `NUMBER`, `AMOUNT`

### CreditTypeCreateRequest

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `INACTIVE`, `DEPRECATED`, `ARCHIVED`
- `name` (string, optional)
- `description` (string, optional, nullable)
- `unit_name` (UnitName, optional)
- `created_at` (string, optional, nullable)
- `updated_at` (string, optional, nullable)

### InvoiceMeterPropertyVariableCreateRequest

- `id` (string, optional, nullable)
- `reference` (string, optional, nullable)
- `name` (string, optional, nullable)
- `type` (enum, optional, nullable)
  - Allowed values: `LIST`

### InvoiceValidationResultCreateRequest

- `status` (string, optional)
- `details` (string, optional)

### InvoiceReprocessCreateRequest

- `to_be_reprocessed_at` (string, optional, nullable)
- `reprocess_status` (string, optional)
- `reprocess_id` (string, optional)

### TaxRegistrationCreateRequest

- `id` (string, optional, nullable) — The id of this tax registration
- `description` (string, optional, nullable) — The description of this tax registration
- `tax_id` (string, optional, nullable) — The tax id of this tax registration, e.g. a TIN, VAT id or other tax number
- `tax_ids` (list of TaxId, optional, nullable) — Tax IDs used for tax purposes of the tax registration, e.g. TINs, VAT ids, or other tax number
- `registration_number` (string, optional, nullable) — The registration number of this tax registration, e.g. a company registration number
- `registered_address` (Address, optional) — The address of this tax registration, if different from the billing entity. Currently, only the address will be used for tax calculations

### InvoiceCouponCreateRequest

- `coupon_id` (string, optional, nullable)
- `coupon_name` (string, optional, nullable)

### InvoicePromotionCodeCreateRequest

- `promotion_code_details` (PromotionCodeDetails, optional, nullable)
- `coupon_id` (string, optional, nullable)

### LinkedIntegrationCreateRequest

- `id` (string, optional)
- `link_details` (list of LinkDetail, optional)

### Customer

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `created_at` (string, optional, nullable)
- `parent_customer_id` (string, optional, nullable) — The parent of the customer. Only returned when there is a single parent.
- `parent_customer_ids` (list of string, optional, nullable) — A list of parents of the customer. Will also be returned if there is a single parent.
- `reference` (string, optional) — A custom reference assigned to the customer.
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`, `CLOSED`
- `timezone` (string, optional, nullable)
- `type` (enum, optional) — The type of customer entity.
  - Allowed values: `ORGANIZATION`, `INDIVIDUAL`
- `email` (string, optional, nullable) — The email of the customer.
- `notification_preferences` (list of NotificationPreference, optional, nullable) — Notification preferences for customer-related communications.
- `locale` (string, optional, nullable) — The locale of the customer. Format is language-country (like en-US).
- `individual` (Individual, optional) — Additional description of the individual customer type.
- `organization` (Organization, optional) — Additional description of the organization customer type.
- `custom_fields` (list of CustomFieldValue, optional, nullable)
- `pricing_plan_subscription_selector` (PricingPlanSubscriptionSelector, optional) — Settings to influence dynamically the subscription to use for the ingest data.
- `linked_integrations` (list of LinkedIntegration, optional, nullable)
- `roles` (list of enum, optional, nullable)
  - Allowed values: `DEFAULT`, `NON_PROCESSING`, `SELF_BILLING`, `SELLER`, `PROCESSING_ONLY`
- `seller_details` (CustomerSellerDetails, optional)
- `processing_only` (boolean, optional, nullable, deprecated)

### BillingEntity

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `created_at` (string, optional, nullable)
- `reference` (string, optional)
- `status` (string, optional, nullable)
- `timezone` (string, optional, nullable)
- `legal_name` (string, optional, nullable) — The legal name of the billing entity.
- `tax_id` (string, optional, nullable) — The ID used for tax purposes of the billing entity.
- `tax_ids` (list of TaxId, optional, nullable) — Tax IDs used for tax purposes of the billing entity
- `registration_number` (string, optional, nullable) — The registration number of the billing entity.
- `registered_address` (Address, optional) — The address associated with the billing entity.
- `email` (string, optional, nullable) — The email address of the billing entity.
- `tax_settings` (TaxSettings, optional) — Customise tax settings for this Billing Entity
- `tax_registrations` (list of TaxRegistration, optional, nullable) — Extra tax registrations for this billing entity
- `custom_fields` (list of CustomFieldValue, optional, nullable)
- `default_customer_country_selector` (list of enum, optional, nullable)
  - Allowed values: `AD`, `AE`, `AF`, `AG`, `AI`, `AL`, `AM`, `AO`, `AQ`, `AR`, `AS`, `AT`, `AU`, `AW`, `AX`, `AZ`, `BA`, `BB`, `BD`, `BE`, `BF`, `BG`, `BH`, `BI`, `BJ`, `BL`, `BM`, `BN`, `BO`, `BQ`, `BR`, `BS`, `BT`, `BV`, `BW`, `BY`, `BZ`, `CA`, `CC`, `CD`, `CF`, `CG`, `CH`, `CI`, `CK`, `CL`, `CM`, `CN`, `CO`, `CR`, `CU`, `CV`, `CW`, `CX`, `CY`, `CZ`, `DE`, `DJ`, `DK`, `DM`, `DO`, `DZ`, `EC`, `EE`, `EG`, `EH`, `ER`, `ES`, `ET`, `FI`, `FJ`, `FK`, `FM`, `FO`, `FR`, `GA`, `GB`, `GD`, `GE`, `GF`, `GG`, `GH`, `GI`, `GL`, `GM`, `GN`, `GP`, `GQ`, `GR`, `GS`, `GT`, `GU`, `GW`, `GY`, `HK`, `HM`, `HN`, `HR`, `HT`, `HU`, `ID`, `IE`, `IL`, `IM`, `IN`, `IO`, `IQ`, `IR`, `IS`, `IT`, `JE`, `JM`, `JO`, `JP`, `KE`, `KG`, `KH`, `KI`, `KM`, `KN`, `KP`, `KR`, `KW`, `KY`, `KZ`, `LA`, `LB`, `LC`, `LI`, `LK`, `LR`, `LS`, `LT`, `LU`, `LV`, `LY`, `MA`, `MC`, `MD`, `ME`, `MF`, `MG`, `MH`, `MK`, `ML`, `MM`, `MN`, `MO`, `MP`, `MQ`, `MR`, `MS`, `MT`, `MU`, `MV`, `MW`, `MX`, `MY`, `MZ`, `NA`, `NC`, `NE`, `NF`, `NG`, `NI`, `NL`, `NO`, `NP`, `NR`, `NU`, `NZ`, `OM`, `PA`, `PE`, `PF`, `PG`, `PH`, `PK`, `PL`, `PM`, `PN`, `PR`, `PS`, `PT`, `PW`, `PY`, `QA`, `RE`, `RO`, `RS`, `RU`, `RW`, `SA`, `SB`, `SC`, `SD`, `SE`, `SG`, `SH`, `SI`, `SJ`, `SK`, `SL`, `SM`, `SN`, `SO`, `SR`, `SS`, `ST`, `SV`, `SX`, `SY`, `SZ`, `TC`, `TD`, `TF`, `TG`, `TH`, `TJ`, `TK`, `TL`, `TM`, `TN`, `TO`, `TR`, `TT`, `TV`, `TW`, `TZ`, `UA`, `UG`, `US`, `UY`, `UZ`, `VA`, `VC`, `VE`, `VG`, `VI`, `VN`, `VU`, `WF`, `WS`, `YE`, `YT`, `ZA`, `ZM`, `ZW`
- `default_billing_currency_selector` (list of enum, optional, nullable)
  - Allowed values: `AED`, `AFN`, `ALL`, `AMD`, `ANG`, `AOA`, `ARS`, `AUD`, `AWG`, `AZN`, `BAM`, `BBD`, `BDT`, `BGN`, `BHD`, `BIF`, `BMD`, `BND`, `BOB`, `BRL`, `BSD`, `BTN`, `BWP`, `BYN`, `BZD`, `CAD`, `CDF`, `CHF`, `CLF`, `CLP`, `CNY`, `COP`, `CRC`, `CUC`, `CUP`, `CVE`, `CZK`, `DJF`, `DKK`, `DOP`, `DZD`, `EGP`, `ERN`, `ETB`, `EUR`, `FJD`, `FKP`, `GBP`, `GEL`, `GHS`, `GIP`, `GMD`, `GNF`, `GTQ`, `GYD`, `HKD`, `HNL`, `HRK`, `HTG`, `HUF`, `IDR`, `ILS`, `INR`, `IQD`, `IRR`, `ISK`, `JMD`, `JOD`, `JPY`, `KES`, `KGS`, `KHR`, `KMF`, `KPW`, `KRW`, `KWD`, `KYD`, `KZT`, `LAK`, `LBP`, `LKR`, `LRD`, `LSL`, `LYD`, `MAD`, `MDL`, `MGA`, `MKD`, `MMK`, `MNT`, `MOP`, `MRO`, `MRU`, `MUR`, `MVR`, `MWK`, `MXN`, `MXV`, `MYR`, `MZN`, `NAD`, `NGN`, `NIO`, `NOK`, `NPR`, `NZD`, `OMR`, `PAB`, `PEN`, `PGK`, `PHP`, `PKR`, `PLN`, `PYG`, `QAR`, `RON`, `RSD`, `RUB`, `RWF`, `SAR`, `SBD`, `SCR`, `SDG`, `SEK`, `SGD`, `SHP`, `SLE`, `SOS`, `SRD`, `SSP`, `STN`, `SVC`, `SYP`, `SZL`, `THB`, `TJS`, `TMT`, `TND`, `TOP`, `TRY`, `TTD`, `TWD`, `TZS`, `UAH`, `UGX`, `USD`, `USN`, `UYI`, `UYU`, `UZS`, `VEF`, `VES`, `VND`, `VUV`, `WST`, `XAF`, `XAG`, `XAU`, `XBA`, `XBB`, `XBC`, `XBD`, `XCD`, `XDR`, `XOF`, `XPD`, `XPF`, `XPT`, `XSU`, `XTS`, `XUA`, `XXX`, `YER`, `ZAR`, `ZMW`, `ZWL`
- `linked_integrations` (list of LinkedIntegration, optional, nullable)

### Amount

- `quantity` (string, optional)
- `currency` (enum, optional)
  - Allowed values: `AED`, `AFN`, `ALL`, `AMD`, `ANG`, `AOA`, `ARS`, `AUD`, `AWG`, `AZN`, `BAM`, `BBD`, `BDT`, `BGN`, `BHD`, `BIF`, `BMD`, `BND`, `BOB`, `BRL`, `BSD`, `BTN`, `BWP`, `BYN`, `BZD`, `CAD`, `CDF`, `CHF`, `CLF`, `CLP`, `CNY`, `COP`, `CRC`, `CUC`, `CUP`, `CVE`, `CZK`, `DJF`, `DKK`, `DOP`, `DZD`, `EGP`, `ERN`, `ETB`, `EUR`, `FJD`, `FKP`, `GBP`, `GEL`, `GHS`, `GIP`, `GMD`, `GNF`, `GTQ`, `GYD`, `HKD`, `HNL`, `HRK`, `HTG`, `HUF`, `IDR`, `ILS`, `INR`, `IQD`, `IRR`, `ISK`, `JMD`, `JOD`, `JPY`, `KES`, `KGS`, `KHR`, `KMF`, `KPW`, `KRW`, `KWD`, `KYD`, `KZT`, `LAK`, `LBP`, `LKR`, `LRD`, `LSL`, `LYD`, `MAD`, `MDL`, `MGA`, `MKD`, `MMK`, `MNT`, `MOP`, `MRO`, `MRU`, `MUR`, `MVR`, `MWK`, `MXN`, `MXV`, `MYR`, `MZN`, `NAD`, `NGN`, `NIO`, `NOK`, `NPR`, `NZD`, `OMR`, `PAB`, `PEN`, `PGK`, `PHP`, `PKR`, `PLN`, `PYG`, `QAR`, `RON`, `RSD`, `RUB`, `RWF`, `SAR`, `SBD`, `SCR`, `SDG`, `SEK`, `SGD`, `SHP`, `SLE`, `SOS`, `SRD`, `SSP`, `STN`, `SVC`, `SYP`, `SZL`, `THB`, `TJS`, `TMT`, `TND`, `TOP`, `TRY`, `TTD`, `TWD`, `TZS`, `UAH`, `UGX`, `USD`, `USN`, `UYI`, `UYU`, `UZS`, `VEF`, `VES`, `VND`, `VUV`, `WST`, `XAF`, `XAG`, `XAU`, `XBA`, `XBB`, `XBC`, `XBD`, `XCD`, `XDR`, `XOF`, `XPD`, `XPF`, `XPT`, `XSU`, `XTS`, `XUA`, `XXX`, `YER`, `ZAR`, `ZMW`, `ZWL`

### Period

- `type` (enum, optional)
  - Allowed values: `DAY`, `WEEK`, `MONTH`, `YEAR`
- `value` (integer, optional, nullable)

### InvoicePeriod

- `period_order` (integer, optional)
- `amount_excluding_tax` (Amount, optional)
- `amount_including_tax` (Amount, optional)
- `billing_period` (Period, optional)
- `start_at` (string, optional)
- `end_at` (string, optional)
- `tax_categories` (list of InvoiceTaxCategorySummary, optional)
- `groups` (list of InvoiceGroup, optional, nullable)

### InvoiceTaxCategorySummary

- `base_amount` (Amount, optional)
- `tax_amount` (Amount, optional)
- `total_amount` (Amount, optional)
- `category` (string, optional)
- `local_amounts` (InvoiceTaxAmounts, optional)
- `notes` (list of string, optional, nullable)
- `rates` (list of InvoiceTaxCategorySummaryRate, optional, nullable)
- `percentage` (string, optional, deprecated)
- `name` (string, optional, deprecated)

### InvoiceTaxTotalSummary

- `base_amount` (Amount, optional)
- `tax_amount` (Amount, optional)
- `total_amount` (Amount, optional)
- `local_amounts` (InvoiceTaxAmounts, optional)
- `notes` (list of string, optional, nullable)
- `country_code` (string, optional)

### InvoiceDunningAction

- `payment_acceptor_id` (string, optional) — Resource ID of type PAYMENT_ACCEPTOR
- `external_reference` (string, optional)
- `status` (enum, optional)
  - Allowed values: `CANCEL_PENDING`, `CANCELLED`, `FAILED`, `PENDING`, `SUCCESSFUL`
- `failure_reason` (string, optional, nullable)
- `first_payment_id` (string, optional, nullable) — Resource ID of type PAYMENT

### InvoicePaymentAction

- `payment_acceptor_id` (string, optional)
- `payment_acceptor` (PaymentAcceptor, optional, nullable)
- `type` (string, optional)
- `bank_account` (InvoicePaymentActionBankAccountDetails, optional)
- `payment_gateway` (InvoicePaymentActionPaymentGatewayDetails, optional)
- `custom_redirect` (InvoicePaymentActionCustomRedirectDetails, optional)

### PortalUrlLink

- `expiry_period` (PortalUrlPeriod, optional, nullable)
- `portal_url_id` (string, optional, nullable) — Resource ID of type PORTAL_URL
- `url` (string, optional, nullable)

### LinkedInvoiceDetail

- `id` (string, optional)
- `link_type` (string, optional)
- `note` (string, optional, nullable)
- `invoice_number` (string, optional, nullable)
- `amount` (Amount, optional)
- `invoice_date` (string, optional, nullable)

### CustomFieldValue

- `id` (string, optional, nullable) — Resource ID of type CUSTOM_FIELD
- `reference` (string, optional, nullable)
- `value` (string, optional, nullable)
- `values` (list of string, optional, nullable)
- `integration_details` (IntegrationDetails, optional, nullable)
- `integration_id` (string, optional) — The resource ID of the integration linked to the custom field

### OtherCustomFieldValue

- `resource` (ResourceIdentifier, optional)
- `id` (string, optional)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `value` (string, optional, nullable)
- `values` (list of string, optional, nullable)

### InvoiceCreditDetail

- `original_invoice_info` (OriginalInvoiceInfo, optional)
- `note` (string, optional)
- `credit_details_source` (enum, optional, nullable) — Source of customer and billing entity information on credit invoices, CURRENT by default.
  - Allowed values: `CURRENT`, `ORIGINAL`
- `original_invoice_id` (string, optional, deprecated)

### EInvoice

- `external_reference` (string, optional, nullable) — The external reference that's used to identify this eInvoice with the eInvoicing integration
- `applied_mandate` (string, optional) — The mandate that was applied to this eInvoice
- `processor` (string, optional) — The eInvoicing integration that processed this eInvoice
- `status` (EInvoiceStatus, optional)
- `status_history` (list of EInvoiceStatus, optional)
- `supported_file_formats` (list of EInvoiceFileFormat, optional) — The file formats in which this eInvoice can be downloaded

### UsedExchangeRate

- `currency` (string, optional)
- `base_currency` (string, optional)
- `rate_timestamp` (string, optional)
- `rate` (string, optional)
- `source` (string, optional, nullable)

### MeterValue

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `status` (enum, optional, nullable) — The status of the meter value indicating the activity and the ability to update properties.
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `type` (enum, optional, nullable) — The type of the meter value.
  - Allowed values: `NUMBER`, `AMOUNT`

### CreditType

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `INACTIVE`, `DEPRECATED`, `ARCHIVED`
- `name` (string, optional)
- `description` (string, optional, nullable)
- `unit_name` (UnitName, optional)
- `created_at` (string, optional, nullable)
- `updated_at` (string, optional, nullable)

### InvoiceMeterPropertyVariable

- `id` (string, optional, nullable)
- `reference` (string, optional, nullable)
- `name` (string, optional, nullable)
- `type` (enum, optional, nullable)
  - Allowed values: `LIST`

### InvoiceValidationResult

- `status` (string, optional)
- `details` (string, optional)

### InvoiceReprocess

- `to_be_reprocessed_at` (string, optional, nullable)
- `reprocess_status` (string, optional)
- `reprocess_id` (string, optional)

### TaxRegistration

- `id` (string, optional, nullable) — The id of this tax registration
- `description` (string, optional, nullable) — The description of this tax registration
- `tax_id` (string, optional, nullable) — The tax id of this tax registration, e.g. a TIN, VAT id or other tax number
- `tax_ids` (list of TaxId, optional, nullable) — Tax IDs used for tax purposes of the tax registration, e.g. TINs, VAT ids, or other tax number
- `registration_number` (string, optional, nullable) — The registration number of this tax registration, e.g. a company registration number
- `registered_address` (Address, optional) — The address of this tax registration, if different from the billing entity. Currently, only the address will be used for tax calculations

### InvoiceCoupon

- `coupon_id` (string, optional, nullable)
- `coupon_name` (string, optional, nullable)

### InvoicePromotionCode

- `promotion_code_details` (PromotionCodeDetails, optional, nullable)
- `coupon_id` (string, optional, nullable)

### LinkedIntegration

- `id` (string, optional)
- `link_details` (list of LinkDetail, optional)

### NotificationPreference

- `type` (enum, optional) — The notification type to configure.
  - Allowed values: `INVOICE`
- `channels` (list of NotificationChannel, optional, nullable) — The channels for this notification type.

### Individual

- `name` (Name, optional)
- `residential_address` (Address, optional)

### Organization

- `legal_name` (string, optional)
- `tax_id` (string, optional, nullable) — Tax Id used for tax purposes of the organization
- `tax_ids` (list of TaxId, optional, nullable) — Tax Ids used for tax purposes of the organization
- `registration_number` (string, optional, nullable)
- `tax_exempt` (boolean, optional, nullable)
- `tax_exempt_note` (string, optional, nullable)
- `registered_address` (Address, optional)
- `tax_registrations` (list of TaxRegistration, optional, nullable) — Extra tax registrations for the customer

### PricingPlanSubscriptionSelector

- `data` (list of PricingPlanSubscriptionSelectorData, optional, nullable)
- `rules` (list of PricingPlanSubscriptionSelectorRule, optional, nullable)
- `filters` (list of PricingPlanSubscriptionSelectorFilter, optional, nullable)
- `fallback` (enum, optional, nullable) — The fallback logic what to do when no subscription is found. By default it is LATEST
  - Allowed values: `LATEST`, `NONE`

### CustomerSellerDetails

- `default_billing_entity_id` (string, optional, nullable) — Resource ID of type BILLING_ENTITY

### TaxId

- `id` (string, optional)
- `type` (enum, optional, nullable) — Optional tax id type, indicates which type of tax the number is for
  - Allowed values: `GENERIC_TAX_ID`, `AU_GST`, `CA_GST_HST`, `CA_PST`, `CA_PST_BC`, `CA_PST_MB`, `CA_PST_SK`, `CA_QST`
- `display_name` (string, optional, nullable) — User-friendly display name
- `tax_id_validation_result` (TaxIdValidation, optional)

### Address

- `line1` (string, optional, nullable)
- `line2` (string, optional, nullable)
- `city` (string, optional, nullable)
- `postal_code` (string, optional, nullable)
- `state` (string, optional, nullable)
- `country` (enum, optional, nullable)
  - Allowed values: `AD`, `AE`, `AF`, `AG`, `AI`, `AL`, `AM`, `AO`, `AQ`, `AR`, `AS`, `AT`, `AU`, `AW`, `AX`, `AZ`, `BA`, `BB`, `BD`, `BE`, `BF`, `BG`, `BH`, `BI`, `BJ`, `BL`, `BM`, `BN`, `BO`, `BQ`, `BR`, `BS`, `BT`, `BV`, `BW`, `BY`, `BZ`, `CA`, `CC`, `CD`, `CF`, `CG`, `CH`, `CI`, `CK`, `CL`, `CM`, `CN`, `CO`, `CR`, `CU`, `CV`, `CW`, `CX`, `CY`, `CZ`, `DE`, `DJ`, `DK`, `DM`, `DO`, `DZ`, `EC`, `EE`, `EG`, `EH`, `ER`, `ES`, `ET`, `FI`, `FJ`, `FK`, `FM`, `FO`, `FR`, `GA`, `GB`, `GD`, `GE`, `GF`, `GG`, `GH`, `GI`, `GL`, `GM`, `GN`, `GP`, `GQ`, `GR`, `GS`, `GT`, `GU`, `GW`, `GY`, `HK`, `HM`, `HN`, `HR`, `HT`, `HU`, `ID`, `IE`, `IL`, `IM`, `IN`, `IO`, `IQ`, `IR`, `IS`, `IT`, `JE`, `JM`, `JO`, `JP`, `KE`, `KG`, `KH`, `KI`, `KM`, `KN`, `KP`, `KR`, `KW`, `KY`, `KZ`, `LA`, `LB`, `LC`, `LI`, `LK`, `LR`, `LS`, `LT`, `LU`, `LV`, `LY`, `MA`, `MC`, `MD`, `ME`, `MF`, `MG`, `MH`, `MK`, `ML`, `MM`, `MN`, `MO`, `MP`, `MQ`, `MR`, `MS`, `MT`, `MU`, `MV`, `MW`, `MX`, `MY`, `MZ`, `NA`, `NC`, `NE`, `NF`, `NG`, `NI`, `NL`, `NO`, `NP`, `NR`, `NU`, `NZ`, `OM`, `PA`, `PE`, `PF`, `PG`, `PH`, `PK`, `PL`, `PM`, `PN`, `PR`, `PS`, `PT`, `PW`, `PY`, `QA`, `RE`, `RO`, `RS`, `RU`, `RW`, `SA`, `SB`, `SC`, `SD`, `SE`, `SG`, `SH`, `SI`, `SJ`, `SK`, `SL`, `SM`, `SN`, `SO`, `SR`, `SS`, `ST`, `SV`, `SX`, `SY`, `SZ`, `TC`, `TD`, `TF`, `TG`, `TH`, `TJ`, `TK`, `TL`, `TM`, `TN`, `TO`, `TR`, `TT`, `TV`, `TW`, `TZ`, `UA`, `UG`, `US`, `UY`, `UZ`, `VA`, `VC`, `VE`, `VG`, `VI`, `VN`, `VU`, `WF`, `WS`, `YE`, `YT`, `ZA`, `ZM`, `ZW`

### TaxSettings

- `apply_local_vat_for_missing_tax_id` (boolean, optional) — Indicates whether to apply VAT when a foreign B2B customer inside the EU has no VAT id configured

### InvoiceGroup

- `group_order` (integer, optional)
- `amount_excluding_tax` (Amount, optional)
- `amount_including_tax` (Amount, optional)
- `billing_period` (Period, optional, nullable)
- `start_at` (string, optional, nullable)
- `end_at` (string, optional, nullable)
- `type` (string, optional, nullable)
- `product_category` (ProductCategory, optional, nullable)
- `products` (list of Product, optional, nullable)
- `pricing` (InvoicePricing, optional, nullable)
- `description` (string, optional, nullable)
- `pricing_plan_subscription_id` (string, optional, nullable)
- `pricing_plan_schedule_id` (string, optional, nullable)
- `forwarded_from_customer_id` (string, optional, nullable)
- `tax_categories` (list of InvoiceTaxCategorySummary, optional)
- `lines` (list of InvoiceLine, optional, nullable)
- `billing_customer_id` (string, optional, nullable, deprecated)

### InvoiceTaxAmounts

- `base_amount` (Amount, optional)
- `tax_amount` (Amount, optional)
- `total_amount` (Amount, optional)
- `used_exchange_rate` (UsedExchangeRate, optional)
- `display` (boolean, optional)

### InvoiceTaxCategorySummaryRate

- `name` (string, optional)
- `percentage` (string, optional)
- `tax_amount` (Amount, optional)

### PaymentAcceptor

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `billing_entity_id` (string, optional, nullable) — Resource ID of type BILLING_ENTITY
- `customer_id` (string, optional, nullable) — Resource ID of type CUSTOMER
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `type` (enum, optional, nullable)
  - Allowed values: `BANK_ACCOUNT`, `PAYMENT_GATEWAY`, `CUSTOM_REDIRECT`
- `bank_account` (BankAccount, optional)
- `payment_gateway` (PaymentGatewayPaymentAcceptor, optional)
- `custom_redirect` (PaymentAcceptorCustomRedirect, optional)
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`

### InvoicePaymentActionBankAccountDetails

- `legal_name` (string, optional)
- `country_code` (string, optional)
- `iban` (string, optional)
- `bic` (string, optional)
- `bank_name` (string, optional)
- `account_number` (string, optional, nullable)
- `bank_code` (string, optional, nullable)
- `sort_code` (string, optional, nullable)
- `reference` (string, optional)
- `routing_number` (string, optional)
- `account_type` (string, optional)
- `type` (string, optional)
- `bank_address` (Address, optional)
- `branch` (string, optional)
- `cbu` (string, optional)
- `clabe` (string, optional)

### InvoicePaymentActionPaymentGatewayDetails

- `variant` (string, optional, nullable)
- `collection_type` (string, optional, nullable)
- `adyen` (AdyenPaymentAction, optional)
- `stripe` (StripePaymentAction, optional)

### InvoicePaymentActionCustomRedirectDetails

- `url` (string, optional, nullable)

### PortalUrlPeriod

- `type` (enum, optional) — The unit of the period. MONTH and YEAR count in the timezone of the customer, or else of the platform.
  - Allowed values: `MINUTE`, `HOUR`, `DAY`, `WEEK`, `MONTH`, `YEAR`
- `value` (integer, optional, nullable) — The number of units after which the link expires.

### IntegrationDetails

- `id` (string, optional, nullable)
- `reference` (string, optional, nullable)
- `payment_gateway_variant` (enum, optional)
  - Allowed values: `ADYEN`, `STRIPE`
- `adyen` (AdyenIntegrationDetails, optional)
- `stripe` (StripeIntegrationDetails, optional)

### ResourceIdentifier

- `type` (enum, optional)
  - Allowed values: `PLATFORM`, `CUSTOMER`, `BILLING_ENTITY`, `METER`, `METER_VALUE`, `METER_PROPERTY`, `METER_VALUE_CALCULATION`, `PRODUCT`, `PRODUCT_ITEM`, `PRODUCT_CATEGORY`, `PRICING`, `PRICING_ITEM`, `PRICING_ITEM_CONFIG`, `PRICING_ITEM_SUMMARY`, `METER_VALUE_CALCULATION_SUMMARY`, `PRICING_PLAN`, `PRICING_PLAN_VERSION`, `PRICING_PLAN_SUBSCRIPTION`, `PRICING_PLAN_SCHEDULE`, `QUOTE`, `QUOTE_VERSION`, `CONTACT`, `CUSTOM_FIELD`, `REQUEST_REFERENCE`, `METER_DATA`, `CHARGE_DATA`, `ADJUSTMENT_DATA`, `PERSIST_DATA`, `INVOICE`, `INVOICE_PAYMENT_ATTEMPT`, `PAYMENT_ACCEPTOR`, `PAYMENT_SCHEDULE`, `PAYMENT_REQUEST`, `FEATURE`, `ALERT_RULE`, `ALERT`, `USER`, `MEMBERSHIP`, `TEAM`, `ENTITY`, `ACCOUNT_GROUP`, `AUDIT`, `WEBHOOK`, `REPORT_SUBSCRIPTION`, `REPORT_CONFIGURATION`
- `id` (string, optional)

### OriginalInvoiceInfo

- `id` (string, optional)
- `invoice_number` (string, optional)

### EInvoiceStatus

- `status` (string, optional, nullable)
- `timestamp` (string, optional, nullable)
- `message` (string, optional, nullable)

### EInvoiceFileFormat

- `type` (string, optional, nullable) — The format of the eInvoice that can be downloaded
- `description` (string, optional, nullable)

### UnitName

- `singular` (string, optional)
- `plural` (string, optional, nullable)

### PromotionCodeDetails

- `promotion_code_id` (string, optional, nullable) — Resource ID of type PROMOTION_CODE
- `code` (string, optional, nullable)

### LinkDetail

- `url` (string, optional, nullable)
- `custom_field_name` (string, optional, nullable)

### NotificationChannel

- `type` (enum, optional) — The channel type to use.
  - Allowed values: `EMAIL`
- `enabled` (boolean, optional, nullable) — Whether the channel is enabled for the notification type.

### Name

- `first_name` (string, optional, nullable)
- `last_name` (string, optional, nullable)
- `infix` (string, optional, nullable)

### PricingPlanSubscriptionSelectorData

- `field` (enum, optional)
  - Allowed values: `BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY`, `PRICING_PLAN_REFERENCE`
- `value` (string, optional)

### PricingPlanSubscriptionSelectorRule

- `field` (enum, optional)
  - Allowed values: `BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY`, `PRICING_PLAN_REFERENCE`
- `type` (enum, optional)
  - Allowed values: `EQUALS`, `NOT_EQUALS`, `IN`, `NOT_IN`, `GREATER_THAN`, `GREATER_THAN_OR_EQUALS`, `LESS_THAN`, `LESS_THAN_OR_EQUALS`, `EMPTY`, `NOT_EMPTY`, `CONTAINS`, `NOT_CONTAINS`

### PricingPlanSubscriptionSelectorFilter

- `field` (enum, optional)
  - Allowed values: `BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY`, `PRICING_PLAN_REFERENCE`
- `type` (enum, optional)
  - Allowed values: `EQUALS`, `NOT_EQUALS`, `IN`, `NOT_IN`, `GREATER_THAN`, `GREATER_THAN_OR_EQUALS`, `LESS_THAN`, `LESS_THAN_OR_EQUALS`, `EMPTY`, `NOT_EMPTY`, `CONTAINS`, `NOT_CONTAINS`
- `value` (string, optional)

### TaxIdValidation

- `id` (string, optional)
- `validation_date` (string, optional)
- `source` (string, optional)
- `valid` (enum, optional)
  - Allowed values: `VALID`, `NOT_VALID`, `UNKNOWN`
- `message` (string, optional, nullable)

### ProductCategory

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `name` (string, optional)
- `reference` (string, optional)
- `description` (string, optional, nullable)
- `tax_category` (enum, optional, nullable) — The default tax category applied to the products in the product category.
  - Allowed values: `STANDARD`, `NO_TAX`, `EXEMPT`
- `display_order` (integer, optional, nullable)
- `customer_id` (string, optional, nullable) — Resource ID of type CUSTOMER

### Product

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `category_id` (string, optional) — The resource ID of the product category, that belongs to the product.
- `category` (ProductCategory, optional, nullable)
- `parent_product_id` (string, optional, nullable) — The resource ID of the original product, to which the product will belong to.
- `name` (string, optional)
- `reference` (string, optional)
- `description` (string, optional, nullable)
- `status` (enum, optional, nullable) — The status of the product.
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `product_type` (enum, optional)
  - Allowed values: `DEFAULT`, `ADDON`
- `tax_category` (enum, optional, nullable) — The default tax category applied to the product.
  - Allowed values: `STANDARD`, `NO_TAX`, `EXEMPT`
- `features` (list of FeatureResourceReference, optional, nullable) — The features associated with the product.
- `custom_fields` (list of CustomFieldValue, optional, nullable)
- `display_order` (integer, optional, nullable) — Determines the order in which products are displayed on overview pages and invoices. The lowest number gets the highest priority.
- `linked_integrations` (list of LinkedIntegration, optional, nullable)
- `billing_entity_id` (string, optional, nullable) — The resource ID of the billing entity linked to this product.
- `customer_id` (string, optional, nullable)
- `agent_context` (AgentContext, optional) — Context for AI agents about this product. Intended for agents, not for customer-facing output.

### InvoicePricing

- `id` (string, optional)
- `name` (string, optional)

### InvoiceLine

- `id` (string, optional, nullable)
- `line_order` (integer, optional, nullable)
- `description` (string, optional, nullable)
- `pricing_item_id` (string, optional, nullable)
- `pricing_item_config_id` (string, optional, nullable)
- `product_items` (list of ProductItem, optional, nullable)
- `type` (string, optional, nullable)
- `pricing_type` (string, optional, nullable) — The type of pricing that is applicable for this line, this value is set when type == REVENUE
- `commitment_type` (string, optional, nullable) — The type of commitment that is applicable for this line, this value is set when type == COMMITMENT
- `discount_type` (string, optional, nullable) — The type of discount that is applicable for this line, this value is set when type == DISCOUNT
- `coupon_data` (InvoiceLineCouponData, optional, nullable) — References to the coupon and promotion code, this value is optionally set when type == DISCOUNT and the discount was applied through a coupon or promo code
- `tax_categories` (list of InvoiceTaxCategorySummary, optional, nullable)
- `amount_excluding_tax` (Amount, optional, nullable)
- `amount_including_tax` (Amount, optional, nullable)
- `conditions` (MeterConditions, optional, nullable)
- `meter_value` (InvoiceLineMeterValue, optional, nullable)
- `details` (PricingItemSummaryPriceDetails, optional, nullable)
- `sub_lines` (list of InvoiceSubLine, optional, nullable)
- `applicable_for_clauses` (list of string, optional, nullable) — The clauses of the subscriptions on this invoice that also apply to this line, only set when type == ONE_OFF

### BankAccount

- `type` (enum, optional, nullable) — Determines what fields should be present in the bank account node.
  - Allowed values: `IBAN`, `BIC_AND_ACCOUNT_NUMBER`, `ACCOUNT_NUMBER_AND_BIC`, `US_BANK_ACCOUNT`, `US_LOCAL`, `UK_LOCAL`, `BR_LOCAL`, `AR_LOCAL`, `MX_LOCAL`
- `iban` (string, optional, nullable)
- `country` (string, optional, nullable)
- `bic` (string, optional, nullable) — The ISO 9362 Business Identifier Code (BIC) of the bank account
- `bank_name` (string, optional, nullable)
- `bank_address` (Address, optional) — The bank address
- `account_number_and_bic` (AccountNumberAndBic, optional)
- `uk_local` (UKLocal, optional)
- `us_local` (USLocal, optional)
- `br_local` (BRLocal, optional)
- `ar_local` (ARLocal, optional)
- `mx_local` (MXLocal, optional)
- `account_number` (string, optional, nullable, deprecated) — A bank account number if IBAN is not used, e.g a USA or UK bank account number
- `bank_code` (string, optional, nullable, deprecated) — A bank code that's used to identify the bank that this account belongs to
- `routing_number` (string, optional, nullable, deprecated) — The 9-digit code that identifies a specific financial institution for transactions in the USA.
- `account_type` (enum, optional, nullable, deprecated) — The bank account type.
  - Allowed values: `CHECKING`, `SAVINGS`

### PaymentGatewayPaymentAcceptor

- `integration_id` (string, optional) — Resource ID of type INTEGRATION
- `integration` (Integration, optional, nullable)
- `store_payment_method` (boolean, optional, nullable)
- `auto_charge_payment_method` (boolean, optional, nullable)
- `collection_type` (enum, optional)
  - Allowed values: `LINK`
- `link` (PaymentGatewayPaymentAcceptorLink, optional)
- `adyen` (PaymentGatewayPaymentAcceptorAdyen, optional)

### PaymentAcceptorCustomRedirect

- `url` (string, optional, nullable)

### AdyenPaymentAction

- `id` (string, optional)
- `session_data` (string, optional)

### StripePaymentAction

- `payment_intent_id` (string, optional, nullable)
- `client_secret` (string, optional, nullable)

### AdyenIntegrationDetails

- `recurring_detail_reference` (string, optional)

### StripeIntegrationDetails

- `payment_method_id` (string, optional)

### FeatureResourceReference

- `id` (string, optional, nullable) — The ID of the feature.
- `reference` (string, optional) — The reference of the feature.

### AgentContext

- `guidance` (string, optional, nullable) — Free-text guidance for AI agents on how to interpret and use this resource.

### ProductItem

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `product_id` (string, optional, nullable) — The resource ID of the product, that belongs to the product item.
- `product` (Product, optional, nullable)
- `name` (string, optional, nullable)
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `reference` (string, optional)
- `description` (string, optional, nullable)
- `type` (enum, optional, nullable) — The type of the product item.
  - Allowed values: `REVENUE`, `DEDUCTION`
- `model_type` (enum, optional, nullable)
  - Allowed values: `USAGE_BASED`, `USAGE_BASED_CONVERSION`, `RECURRING`, `ONE_OFF`, `PER_SEAT`, `CREDITS`
- `usage_based` (ProductItemUsageBased, optional) — Additional settings in case of a USAGE_BASED type.
- `credits` (ProductItemCredits, optional) — Additional settings in case of a CREDITS type.
- `meter_value_calculation` (MeterValueCalculation, optional, nullable)
- `tax_category` (enum, optional, nullable) — The default tax category applied to the product item.
  - Allowed values: `STANDARD`, `NO_TAX`, `EXEMPT`
- `display_order` (integer, optional, nullable)
- `unit_name` (UnitName, optional)
- `custom_fields` (list of CustomFieldValue, optional, nullable) — Custom fields associated to this product item
- `customer_id` (string, optional, nullable)
- `agent_context` (AgentContext, optional) — Context for AI agents about this product item. Intended for agents, not for customer-facing output.
- `meter_value_calculation_id` (string, optional, nullable, deprecated) — The linked meter value calculation, in case of a USAGE_BASED charge type.
- `report_meter_value_calculation_ids` (list of string, optional, nullable, deprecated) — Optional reporting meter value calculations, in case of a USAGE_BASED charge type.

### InvoiceLineCouponData

- `coupon_id` (string, optional)
- `promotion_code_id` (string, optional, nullable)

### MeterConditions

- `name` (string, optional, nullable)
- `expression` (MeterConditionExpression, optional)
- `meter_properties` (list of MeterPropertyCondition, optional, nullable, deprecated)

### InvoiceLineMeterValue

- `reference` (string, optional)
- `type` (string, optional)
- `number` (string, optional, nullable)
- `amount` (Amount, optional)

### PricingItemSummaryPriceDetails

- `amount` (Amount, optional)
- `pricing_currency` (string, optional, nullable)
- `pricing_amount` (Amount, optional)
- `conversion` (PricingItemSummaryPriceDetailsConversion, optional)
- `band` (PricingItemSummaryPriceDetailsBand, optional)
- `meter_value` (PricingItemSummaryMeterValue, optional)
- `tiering_meter_value` (PricingItemSummaryMeterValue, optional)
- `price_bound` (string, optional, nullable)
- `meter_values` (list of IngestDataSummary, optional)
- `report_meter_values` (list of ReportIngestDataSummary, optional)
- `description` (string, optional, nullable)
- `used_exchange_rates` (list of UsedExchangeRate, optional, nullable)
- `included_volume_details` (PricingItemSummaryIncludedVolumeDetails, optional)
- `wallet_balance_details` (PricingItemSummaryWalletBalanceDetails, optional)
- `wallet_balances` (list of PricingItemSummaryWalletBalance, optional, nullable)
- `used_wallet_grants` (list of UsedWalletGrantDetail, optional, nullable)
- `split_pricing` (PricingItemConfigSplitPricing, optional, nullable)
- `meter_value_share_of_total` (string, optional, nullable)
- `meter_value_share_of_processing_only_customer_total` (string, optional, nullable)

### InvoiceSubLine

- `sub_line_order` (integer, optional)
- `details` (PricingItemSummaryPriceDetails, optional)
- `description` (string, optional, nullable)
- `processing_only_customer_id` (string, optional, nullable)
- `type` (enum, optional, nullable)
  - Allowed values: `USAGE_BASED_CONVERSION`
- `usage_based_conversion` (InvoiceSubLineUsageBasedConversion, optional)
- `processing_only_customer_resource_id` (string, optional, nullable, deprecated)

### AccountNumberAndBic

- `account_number` (string, optional, nullable) — A bank account number if IBAN is not used, e.g a USA or UK bank account number
- `bank_code` (string, optional, nullable) — A bank code that's used to identify the bank that this account belongs to
- `bic` (string, optional, nullable) — The ISO 9362 Business Identifier Code (BIC) of the bank account

### UKLocal

- `account_number` (string, optional, nullable) — A bank account number if IBAN is not used, e.g a USA or UK bank account number
- `sort_code` (string, optional, nullable)

### USLocal

- `account_number` (string, optional, nullable) — A bank account number if IBAN is not used, e.g a USA or UK bank account number
- `account_type` (enum, optional, nullable) — The bank account type.
  - Allowed values: `CHECKING`, `SAVINGS`
- `bank_code` (string, optional, nullable) — A bank code that's used to identify the bank that this account belongs to
- `routing_number` (string, optional, nullable) — The 9-digit code that identifies a specific financial institution for transactions in the USA.

### BRLocal

- `branch` (string, optional, nullable) — Identifier of the bank branch (agência)
- `account_number` (string, optional, nullable) — A bank account number if IBAN is not used, in Brazil known as a conta
- `bic` (string, optional, nullable) — The ISO 9362 Business Identifier Code (BIC) of the bank account

### ARLocal

- `cbu` (string, optional, nullable) — CBU (Clave Bancaria Uniforme) account identifier
- `account_number` (string, optional, nullable) — A bank account number if IBAN is not used
- `bic` (string, optional, nullable) — The ISO 9362 Business Identifier Code (BIC) of the bank account

### MXLocal

- `clabe` (string, optional, nullable) — CLABE (Clave Bancaria Estandarizada) account identifier
- `account_number` (string, optional, nullable) — A bank account number if IBAN is not used
- `bic` (string, optional, nullable) — The ISO 9362 Business Identifier Code (BIC) of the bank account

### Integration

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional) — A custom reference assigned to the integration.
- `name` (string, optional) — A custom name assigned to the integration.
- `description` (string, optional)
- `status` (enum, optional, nullable) — The status of the integration.
  - Allowed values: `DRAFT`, `PENDING`, `TESTING`, `ACTIVE`, `ERROR`, `DEPRECATED`, `ARCHIVED`
- `message` (string, optional, nullable) — The message associated with the status of the integration.
- `type` (enum, optional) — The type of integration.
  - Allowed values: `PAYMENT_GATEWAY`, `E_INVOICING`, `TAX_CALCULATION`, `DATA_EXPORT`, `EMAIL_PROVIDER`, `ERP`
- `variant` (enum, optional) — The variant of the integration.
  - Allowed values: `DEFAULT`, `PARAGON_MULTI_ACCOUNT`
- `paragon_settings` (ParagonSettings, optional) — Paragon integration settings, e.g. the Paragon credential id. Applicable when the variant is PARAGON_MULTI_ACCOUNT.
- `authentication` (AuthenticationSettings, optional) — The authentication information used for the integration
- `payment_gateway` (PaymentGatewayIntegration, optional)
- `e_invoicing` (EInvoicingIntegration, optional) — Integration to do eInvoicing
- `data_export` (DataExportIntegration, optional)
- `tax_calculation` (TaxCalculationIntegration, optional) — Integration to calculate tax
- `linked_resources_configurations` (list of IntegrationLinkedResourceConfiguration, optional) — Details from the resources configurations from Solvimon linked to external integration system
- `email_provider` (EmailProviderIntegration, optional) — Email provider integration settings. Applicable when the integration type is EMAIL_PROVIDER.
- `erp` (ErpIntegration, optional) — ERP integration settings. Applicable when the integration type is ERP.

### PaymentGatewayPaymentAcceptorLink

- `expiry_period` (Period, optional)

### PaymentGatewayPaymentAcceptorAdyen

- `auto_rescue` (AdyenAutoRescue, optional)
- `merchant_account` (string, optional, nullable)
- `allowed_payment_methods` (list of string, optional, nullable) — The Adyen payment method types allowed for this payment acceptor. Must be a subset of the integration's enabled_payment_methods, when enabled_payment_methods is set.

### ProductItemUsageBased

- `meter_value_calculation_id` (string, optional, nullable) — The linked meter value calculation
- `meter_value_calculation` (MeterValueCalculation, optional, nullable)
- `tiering_meter_value_calculation_id` (string, optional, nullable) — The optional alternative linked meter value calculation for tiering
- `tiering_meter_value_calculation` (MeterValueCalculation, optional, nullable)
- `report_meter_value_calculation_ids` (list of string, optional, nullable) — Optional reporting meter value calculations.
- `conditions` (MeterConditions, optional) — Optional conditions.

### ProductItemCredits

- `credit_type_id` (string, optional, nullable) — The linked meter value calculation
- `credit_type` (CreditType, optional, nullable)

### MeterValueCalculation

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `calculation_type` (enum, optional, nullable) — The type of calculation used for this billable metric.
  - Allowed values: `SUM`, `MAX`, `MIN`, `AVERAGE`, `UNIQUE`
- `persist` (boolean, optional, nullable) — Indicate if the data of the billable metric must be persisted to the next billing period of the schedule (default is false).
- `meter_id` (string, optional, nullable) — The ID of the meter.
- `meter` (Meter, optional, nullable)
- `meter_value_id` (string, optional, nullable) — The ID of the meter value.
- `meter_value` (MeterValue, optional, nullable)
- `meter_property_id` (string, optional, nullable) — The ID of the meter property.
- `meter_property` (MeterProperty, optional, nullable)

### MeterConditionExpression

- `operator` (enum, optional)
  - Allowed values: `AND`, `OR`, `XOR`
- `operands` (list of MeterConditionOperand, optional, nullable)

### MeterPropertyCondition

- `id` (string, optional, nullable) — Resource ID of type METER_PROPERTY
- `reference` (string, optional, nullable)
- `meter_property` (MeterProperty, optional, nullable)
- `value` (string, optional, nullable)
- `values` (list of string, optional, nullable)
- `meter_property_variable_id` (string, optional, nullable) — Resource ID of type METER_PROPERTY_VARIABLE
- `meter_property_variable` (MeterPropertyVariable, optional, nullable)
- `comparator` (enum, optional)
  - Allowed values: `EQUALS`, `NOT_EQUALS`, `IN`, `NOT_IN`, `GREATER_THAN`, `GREATER_THAN_OR_EQUALS`, `LESS_THAN`, `LESS_THAN_OR_EQUALS`, `EMPTY`, `NOT_EMPTY`, `CONTAINS`, `NOT_CONTAINS`

### PricingItemSummaryPriceDetailsConversion

- `credits` (Credits, optional)
- `convert_from_meter_value_id` (string, optional)

### PricingItemSummaryPriceDetailsBand

- `amount` (Amount, optional)
- `percentage` (string, optional, nullable)
- `credits` (Credits, optional)
- `maximum_amount` (Amount, optional)
- `minimum_amount` (Amount, optional)
- `maximum_number` (string, optional, nullable)
- `minimum_number` (string, optional, nullable)
- `block_size` (PricingItemConfigMeterValue, optional)
- `tier_lower_bound` (PricingItemConfigMeterValue, optional)
- `tier_top_bound` (PricingItemConfigMeterValue, optional)
- `volume_share` (string, optional, nullable)
- `included_volume` (PricingItemConfigMeterValue, optional)

### PricingItemSummaryMeterValue

- `id` (string, optional, nullable) — Resource ID of type METER_VALUE
- `reference` (string, optional, nullable)
- `number` (string, optional, nullable) — Number value of the meter value, will be set when type == NUMBER
- `amount` (Amount, optional) — Amount value of the meter value, will be set when type == AMOUNT
- `count` (string, optional, nullable)
- `ratio` (string, optional, nullable)
- `type` (enum, optional, nullable) — Type of the meter value
  - Allowed values: `NUMBER`, `AMOUNT`

### IngestDataSummary

- `number` (string, optional, nullable)
- `amount` (Amount, optional)
- `amount_in_pricing_currency` (Amount, optional)
- `count` (long, optional)
- `ratio` (string, optional, nullable)

### ReportIngestDataSummary

- `meter_value_calculation_id` (string, optional)
- `number` (string, optional, nullable)
- `amount` (Amount, optional)
- `amount_in_pricing_currency` (Amount, optional)
- `count` (string, optional, nullable)
- `ratio` (string, optional, nullable)

### PricingItemSummaryIncludedVolumeDetails

- `included_volume` (PricingItemSummaryMeterValue, optional)
- `available_included_volume` (PricingItemSummaryMeterValue, optional)
- `period_volume` (PricingItemSummaryMeterValue, optional)

### PricingItemSummaryWalletBalanceDetails

- `used_wallet_credits` (Credits, optional) — Deprecated, use `wallet_balances`. The credits that are used from the wallet
- `left_wallet_credits` (Credits, optional) — Deprecated, use `wallet_balances`. The credits still left after this charge, out of those this charge could be paid from. This can be used in case there will come more usage
- `available_wallet_credits` (Credits, optional) — Deprecated, use `wallet_balances`. The credits this charge could be paid from, before it was paid. The credits available can be more than used, in case credits are reserved/ used for other charges, or in case the usage is less than available.

### PricingItemSummaryWalletBalance

- `wallet_id` (string, optional, nullable)
- `used_balance` (WalletBalanceValue, optional, nullable) — What this charge took out of the wallet. A wallet that pays in money reports a net amount: it reduces the taxable base of the charge, because the tax was already charged when the wallet was funded.
- `left_balance` (WalletBalanceValue, optional, nullable) — What is still left on this wallet after the charge, out of the balance it could be paid from. This can be used in case there will come more usage
- `available_balance` (WalletBalanceValue, optional, nullable) — The balance this charge could be paid from, before it was paid. What is available can be more than what is used, in case the balance is reserved/ used for other charges, or in case the usage is less than available.

### UsedWalletGrantDetail

- `wallet_id` (string, optional, nullable)
- `wallet_grant_id` (string, optional, nullable)
- `used_balance` (WalletBalanceValue, optional, nullable) — What this charge took out of this grant.
- `balance_at` (string, optional, nullable) — The date the balance was read at, which is the start of the period the charge belongs to.
- `paid_at` (string, optional, nullable) — The date the grant is drawn on.

### PricingItemConfigSplitPricing

- `meter_properties` (list of MeterPropertySplitPricing, optional, nullable)

### InvoiceSubLineUsageBasedConversion

- `conditions` (MeterConditions, optional)

### ParagonSettings

- `paragon_external_id` (string, optional, nullable) — The external id of the integration in the third-party system, e.g. the Paragon credential id.

### AuthenticationSettings

- `api_key` (AuthenticationSettingsApiKey, optional)
- `client_credentials` (ClientCredentials, optional)
- `username_password` (UsernamePassword, optional)

### PaymentGatewayIntegration

- `variant` (enum, optional) — The variant of payment integration.
  - Allowed values: `ADYEN`, `STRIPE`
- `adyen` (AdyenPaymentGatewayIntegration, optional)
- `stripe` (StripePaymentGatewayIntegration, optional)

### EInvoicingIntegration

- `mandates` (list of EInvoicingMandate, optional) — The mandates that are used for eInvoicing
- `processor` (enum, optional)
  - Allowed values: `AVALARA`

### DataExportIntegration

- `variant` (enum, optional) — The variant of payment integration.
  - Allowed values: `S3`, `BIGQUERY`, `GCS`, `SNOWFLAKE`
- `s3` (S3, optional)
- `bigquery` (BigQuery, optional)
- `gcs` (Gcs, optional)
- `snowflake` (Snowflake, optional)
- `transport_type` (string, optional, nullable)

### TaxCalculationIntegration

- `billing_entity_id` (string, optional) — The id of the billing entity for which this integration is used
- `variant` (enum, optional) — The variant that provides the tax calculation
  - Allowed values: `AVATAX`
- `ava_tax` (AvaTaxCalculationIntegration, optional) — Details for an AvaTax integration
- `custom_tax_codes` (list of CustomTaxCode, optional) — Optional: custom codes that are used to link specific taxes to the tax calculation (e.g. commitments, missing product codes, etc.)
- `enable_tax_filing` (boolean, optional) — Determines whether invoices will be sent to the tax integration, or just calculations

### IntegrationLinkedResourceConfiguration

- `resource_type` (string, optional)
- `link_details` (list of IntegrationLinkDetail, optional)

### EmailProviderIntegration

- `variant` (enum, optional) — The variant of email provider integration.
  - Allowed values: `SYSTEM`, `MAILGUN`
- `mailgun` (MailgunEmailProvider, optional) — Mailgun-specific provider settings. Applicable when variant is MAILGUN.
- `delivery_window` (Period, optional) — Optional delivery window configuration that limits when outbound emails may be sent.

### ErpIntegration

- `variant` (enum, optional)
  - Allowed values: `XERO`

### AdyenAutoRescue

- `enabled` (boolean, optional, nullable)
- `period` (Period, optional)

### Meter

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `status` (enum, optional, nullable) — The status of the meter indicating the activity of the meter and the ability to update properties.
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `meter_values` (list of MeterMeterValue, optional, nullable) — The values used as input to calculate billable units, used in the meter.
- `meter_properties` (list of MeterMeterProperty, optional, nullable) — The properties that provide information to give context to an event, used in the meter.

### MeterProperty

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `status` (enum, optional) — The status of the meter property indicating the activity and the ability to update properties.
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `type` (enum, optional, nullable) — The type of the meter property.
  - Allowed values: `NUMBER`, `ENUM`, `STRING`
- `enum_values` (list of string, optional, nullable) — The list of available ENUM values.

### MeterConditionOperand

- `meter_property` (MeterPropertyCondition, optional)
- `expression` (MeterConditionOperandExpression, optional, nullable)

### MeterPropertyVariable

- `object_type` (string, optional, nullable)
- `id` (string, optional, nullable)
- `reference` (string, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `meter_property_id` (string, optional, nullable) — The meter property whose values this variable lists. Set on create only.
- `meter_property_reference` (string, optional, nullable) — Alternative to meter_property_id on create.
- `type` (enum, optional, nullable)
  - Allowed values: `LIST`
- `status` (enum, optional, nullable)
  - Allowed values: `DRAFT`, `ACTIVE`, `ARCHIVED`, `DEPRECATED`
- `values` (list of string, optional, nullable) — The initial values, on create only. Edit them afterwards through the values endpoint.
- `value_count` (integer, optional, nullable)
- `created_at` (string, optional, nullable)
- `updated_at` (string, optional, nullable)

### Credits

- `quantity` (string, optional)
- `credit_type_id` (string, optional) — Resource ID of type CREDIT_TYPE
- `credit_type` (CreditType, optional, nullable)

### PricingItemConfigMeterValue

- `number` (string, optional, nullable)
- `amount` (Amount, optional)
- `count` (string, optional, nullable)

### WalletBalanceValue

- `credits` (Credits, optional, nullable)
- `amount` (Amount, optional, nullable)

### MeterPropertySplitPricing

- `id` (string, optional, nullable) — Resource ID of type METER_PROPERTY
- `reference` (string, optional, nullable)
- `value` (string, optional, nullable)
- `meter_property` (MeterProperty, optional, nullable)

### AuthenticationSettingsApiKey

- `header` (string, optional, nullable)
- `value` (string, optional, nullable)

### ClientCredentials

- `client_id` (string, optional)
- `client_secret` (string, optional)

### UsernamePassword

- `username` (string, optional)
- `password` (string, optional)

### AdyenPaymentGatewayIntegration

- `company_account` (string, optional)
- `environment` (enum, optional)
  - Allowed values: `LIVE`, `TEST`
- `live_prefix` (string, optional)
- `merchant_accounts` (list of string, optional)
- `public_key` (string, optional)
- `signing_secret` (string, optional)
- `ownership` (enum, optional)
  - Allowed values: `PLATFORM`, `SYSTEM`
- `system_ownership_details` (SystemOwnershipDetails, optional)
- `balance_platform_details` (BalancePlatformDetails, optional)
- `legal_entity_manager_details` (LegalEntityManagerDetails, optional)
- `enabled_payment_methods` (list of string, optional, nullable) — The Adyen payment method types enabled for this integration.

### StripePaymentGatewayIntegration

- `public_key` (string, optional)
- `signing_secret` (string, optional, nullable)

### EInvoicingMandate

- `name` (string, optional) — The name of the mandate
- `country` (string, optional, nullable) — The country that this mandate belongs to
- `mappings` (list of EInvoicingMapping, optional, nullable) — The mappings that are used for this Mandate. If not provided, all mappings will be default. If provided, will be merged with defaults
- `condition_groups` (list of EInvoicingConditionGroup, optional, nullable) — The condition groups that are used for this mandate. If provided, no defaults will be used. The mandate applies if 1 conditionGroup applies
- `include_pdf_in_einvoice` (boolean, optional, nullable) — Whether the PDF should be included in the submitted eInvoice payload when supported
- `supported_file_formats` (list of EInvoiceFileFormat, optional, nullable) — The file formats in which eInvoices for this mandate can be downloaded

### S3

- `bucket_name` (string, optional)
- `bucket_path` (string, optional)
- `bucket_region` (string, optional)
- `authentication_type` (enum, optional, nullable)
  - Allowed values: `ACCESS_KEY_AND_SECRET`, `IAM_ROLE`
- `role_arn` (string, optional, nullable)
- `external_id` (string, optional, nullable)

### BigQuery

- `project_id` (string, optional)
- `dataset_id` (string, optional)
- `dataset_location` (string, optional)
- `gcs_bucket_name` (string, optional)
- `gcs_hmac_key_access_id` (string, optional)
- `gcs_hmac_key_secret` (string, optional)

### Gcs

- `bucket_region` (string, optional)
- `bucket_name` (string, optional)
- `bucket_path` (string, optional)
- `flattening` (boolean, optional)

### Snowflake

- `host` (string, optional, nullable)
- `role` (string, optional, nullable)
- `warehouse` (string, optional, nullable)
- `database` (string, optional, nullable)
- `schema` (string, optional, nullable)

### AvaTaxCalculationIntegration

- `company_code` (string, optional) — Links a billing entity to a company in AvaTax

### CustomTaxCode

- `field` (enum, optional) — The field to use a custom code for
  - Allowed values: `INVOICE_COMMITMENT`, `PRODUCT_FALLBACK`
- `value` (string, optional)

### IntegrationLinkDetail

- `base_url` (string, optional)
- `custom_field_reference` (string, optional)

### MailgunEmailProvider

- `domain` (string, optional) — Mailgun sending domain used for this email provider integration.
- `region` (enum, optional, nullable) — Mailgun region for the configured domain.
  - Allowed values: `US`, `EU`
- `plan` (string, optional, nullable) — Optional Mailgun plan stored with the integration.

### MeterMeterValue

- `id` (string, optional, nullable) — Resource ID of type METER_VALUE
- `object` (MeterValue, optional, nullable)
- `reference` (string, optional, nullable)
- `required` (boolean, optional, nullable)

### MeterMeterProperty

- `id` (string, optional, nullable) — Resource ID of type METER_PROPERTY
- `object` (MeterProperty, optional, nullable)
- `reference` (string, optional, nullable)
- `required` (boolean, optional, nullable)

### MeterConditionOperandExpression

### SystemOwnershipDetails

- `account_holder_id` (string, optional)
- `balance_account_id` (string, optional)
- `legal_entity_id` (string, optional)
- `store_id` (string, optional)

### BalancePlatformDetails

- `account` (string, optional)
- `authentication` (AuthenticationSettings, optional)

### LegalEntityManagerDetails

- `authentication` (AuthenticationSettings, optional)

### EInvoicingMapping

- `target` (string, optional) — The target field for a UBL Invoice
- `source` (string, optional, nullable) — The source field from a Solvimon Invoice
- `description` (string, optional, nullable) — Optional description for the mapping

### EInvoicingConditionGroup

- `conditions` (list of EInvoicingCondition, optional) — Conditions that determine whether this conditionGroup matches the invoice. All conditions need to match for the group to match

### EInvoicingCondition

- `field` (string, optional) — The field that holds the value to compare against
- `comparator_type` (enum, optional)
  - Allowed values: `EQUALS`, `NOT_EQUALS`, `IN`, `NOT_IN`, `GREATER_THAN`, `GREATER_THAN_OR_EQUALS`, `LESS_THAN`, `LESS_THAN_OR_EQUALS`, `EMPTY`, `NOT_EMPTY`, `CONTAINS`, `NOT_CONTAINS`
- `value` (string, optional) — Value to check the field against. If a Comparator such as 'IN' or 'CONTAINS' is used, this can be a comma separated list of values

## Examples

**Request**

```json
{
  "type": "ONE_OFF",
  "customer_id": "cust_UwDeeN0vxxHxMTCJeF1K",
  "due_date": "2026-11-08T00:00:00Z",
  "pricing_amount_type": "EXCLUDING_TAX",
  "payment_acceptor_ids": [
    "paya_XwDeeN0vxxHylgCKvD1n"
  ]
}
```

**Response**

```json
{
  "object_type": "string",
  "id": "string",
  "invoice_number": "string",
  "purchase_order_number": "string",
  "platform_id": "string",
  "customer_id": "string",
  "customer_reference": "string",
  "sales_tax_percentage": "string",
  "customer": {
    "object_type": "string",
    "id": "string",
    "created_at": "string",
    "parent_customer_id": "string",
    "parent_customer_ids": [
      "string"
    ],
    "reference": "string",
    "status": "DRAFT",
    "timezone": "string",
    "type": "ORGANIZATION",
    "email": "string",
    "notification_preferences": [
      {
        "type": "INVOICE",
        "channels": [
          {
            "type": "EMAIL",
            "enabled": true
          }
        ]
      }
    ],
    "locale": "string",
    "individual": {
      "name": {
        "first_name": "string",
        "last_name": "string",
        "infix": "string"
      },
      "residential_address": {
        "line1": "string",
        "line2": "string",
        "city": "string",
        "postal_code": "string",
        "state": "string",
        "country": "AD"
      }
    },
    "organization": {
      "legal_name": "string",
      "tax_id": "string",
      "tax_ids": [
        {
          "id": "string",
          "type": "GENERIC_TAX_ID",
          "display_name": "string",
          "tax_id_validation_result": {
            "id": "string",
            "validation_date": "string",
            "source": "string",
            "valid": "VALID",
            "message": "string"
          }
        }
      ],
      "registration_number": "string",
      "tax_exempt": true,
      "tax_exempt_note": "string",
      "registered_address": {
        "line1": "string",
        "line2": "string",
        "city": "string",
        "postal_code": "string",
        "state": "string",
        "country": "AD"
      },
      "tax_registrations": [
        {
          "id": "string",
          "description": "string",
          "tax_id": "string",
          "tax_ids": [
            {
              "id": "string",
              "type": "GENERIC_TAX_ID",
              "display_name": "string",
              "tax_id_validation_result": {
                "id": "string",
                "validation_date": "string",
                "source": "string",
                "valid": "VALID",
                "message": "string"
              }
            }
          ],
          "registration_number": "string",
          "registered_address": {
            "line1": "string",
            "line2": "string",
            "city": "string",
            "postal_code": "string",
            "state": "string",
            "country": "AD"
          }
        }
      ]
    },
    "custom_fields": [
      {
        "id": "string",
        "reference": "string",
        "value": "string",
        "values": [
          "string"
        ],
        "integration_details": {
          "id": "string",
          "reference": "string",
          "payment_gateway_variant": "ADYEN",
          "adyen": {
            "recurring_detail_reference": "string"
          },
          "stripe": {
            "payment_method_id": "string"
          }
        },
        "integration_id": "string"
      }
    ],
    "pricing_plan_subscription_selector": {
      "data": [
        {
          "field": "BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY",
          "value": "string"
        }
      ],
      "rules": [
        {
          "field": "BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY",
          "type": "EQUALS"
        }
      ],
      "filters": [
        {
          "field": "BILLING_ENTITY_REGISTERED_ADDRESS_COUNTRY",
          "type": "EQUALS",
          "value": "string"
        }
      ],
      "fallback": "LATEST"
    },
    "linked_integrations": [
      {
        "id": "string",
        "link_details": [
          {
            "url": "string",
            "custom_field_name": "string"
          }
        ]
      }
    ],
    "roles": [
      "DEFAULT"
    ],
    "seller_details": {
      "default_billing_entity_id": "string"
    },
    "processing_only": true
  },
  "billing_entity": {
    "object_type": "string",
    "id": "string",
    "created_at": "string",
    "reference": "string",
    "status": "string",
    "timezone": "string",
    "legal_name": "string",
    "tax_id": "string",
    "tax_ids": [
      {
        "id": "string",
        "type": "GENERIC_TAX_ID",
        "display_name": "string",
        "tax_id_validation_result": {
          "id": "string",
          "validation_date": "string",
          "source": "string",
          "valid": "VALID",
          "message": "string"
        }
      }
    ],
    "registration_number": "string",
    "registered_address": {
      "line1": "string",
      "line2": "string",
      "city": "string",
      "postal_code": "string",
      "state": "string",
      "country": "AD"
    },
    "email": "string",
    "tax_settings": {
      "apply_local_vat_for_missing_tax_id": true
    },
    "tax_registrations": [
      {
        "id": "string",
        "description": "string",
        "tax_id": "string",
        "tax_ids": [
          {
            "id": "string",
            "type": "GENERIC_TAX_ID",
            "display_name": "string",
[...]
